SystemOrganization addCategory: #'MsgPack-Core-Tests'!
SystemOrganization addCategory: #'MsgPack-Core'!
SystemOrganization addCategory: #'MsgPack-RPC'!
SystemOrganization addCategory: #'MsgPack-RPC-Tests'!
SystemOrganization addCategory: #'MsgPack-IDL-Tests'!
SystemOrganization addCategory: #'MsgPack-IDL'!
SystemOrganization addCategory: #'MsgPack-IDL-Generator-Tests'!
SystemOrganization addCategory: #'MsgPack-IDL-Generator'!

!LargeNegativeInteger methodsFor: '*MsgPack' stamp: 'PanuSuominen 11/10/2011 19:51'!
messagePackOn: aStream
	| value |
	self >= -2147483648 ifTrue:[
			MsgPack messagePackInt32: self on: aStream.
		^ aStream
	].
	MsgPack messagePackInt64: self on: aStream.
	^ aStream.
	! !

!ByteArray methodsFor: '*MsgPack' stamp: 'PanuSuominen 6/9/2011 09:34'!
messagePackOn: aWriteStream 
	self size < 32 ifTrue:[
		aWriteStream nextPut: (self size bitOr: 2r10100000).
		aWriteStream nextPutAll: self.
		^aWriteStream.
	].
	self size <= 16rFFFF ifTrue:[
		aWriteStream nextPut: 16rDA.
		aWriteStream uint16: self size.
		aWriteStream nextPutAll: self.
		^aWriteStream.
	].
	aWriteStream nextPut: 16rDB.
		aWriteStream uint32: self size.
		aWriteStream nextPutAll: self.
		^aWriteStream.
! !

!ByteArray methodsFor: '*MsgPack' stamp: 'PanuWetterstrand 10/15/2012 21:03'!
messageUnpack
	^MsgPack messageUnpack: self.! !

Error subclass: #MsgPackUnknownType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!UndefinedObject methodsFor: '*MsgPack' stamp: 'PanuSuominen 6/9/2011 09:34'!
messagePackOn: aWriteStream 
	aWriteStream nextPut: 16rC0.! !

!String methodsFor: '*MsgPack-IDL' stamp: 'PanuSuominen 12/5/2011 20:46'!
asMessagePackIDL
	^MsgPackIDL parse: self.! !

!String methodsFor: '*MsgPack' stamp: 'PanuSuominen 10/28/2011 13:23'!
messagePackOn: aWriteStream
	( UTF8TextConverter new convertToSystemString: self) asByteArray messagePackOn: aWriteStream.
! !

!Collection methodsFor: '*MsgPack' stamp: 'PanuSuominen 6/9/2011 09:34'!
messagePackOn: aWriteStream
	(self size between: 0 and: 15)
		ifTrue: [ aWriteStream nextPut: (self size bitOr: 2r10010000) ]
		ifFalse: [ 
			(self size between: 16 and: 16rFFFF)
				ifTrue: [ 
					aWriteStream nextPut: 16rDC.
					aWriteStream uint16: self size ]
				ifFalse: [ 
					aWriteStream nextPut: 16rDD.
					aWriteStream uint32: self size ] ].
	self do: [ :element | element messagePackOn: aWriteStream ].
	^ aWriteStream! !

!Collection methodsFor: '*MsgPack' stamp: 'PanuWetterstrand 10/15/2012 21:27'!
messageUnpack
	^self asByteArray messageUnpack.! !

!Float methodsFor: '*MsgPack' stamp: 'PanuSuominen 11/10/2011 20:53'!
messagePackOn: aWriteStream
	MsgPack messagePackFloat: self on: aWriteStream! !

!False methodsFor: '*MsgPack' stamp: 'PanuSuominen 6/9/2011 09:34'!
messagePackOn: aWriteStream 
	aWriteStream nextPut: 16rC2.! !

!True methodsFor: '*MsgPack' stamp: 'PanuSuominen 6/9/2011 09:34'!
messagePackOn: aWriteStream 
	aWriteStream nextPut: 16rC3.! !

Array variableSubclass: #MsgPackRPCMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC'!

!MsgPackRPCMessage class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:50'!
messageSize
	^ self subclassResponsibility! !

!MsgPackRPCMessage class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 21:17'!
messageUnpackFrom: aReadStream
	"Unpacs RPC message from stream. Decides between notice, request and response messages."

	| array class type |
	array := MsgPack messageUnpackNext: aReadStream.
	type := 0.
	array size = 4
		ifTrue: [ type := array at: 2 ].
	array size = 3
		ifTrue: [ 
			type := array at: 1.
			class := MsgPackRPCNotification ].
	type = 0
		ifTrue: [ class := MsgPackRPCRequest ].
	type = 1
		ifTrue: [ class := MsgPackRPCResponse ].
	type = 2
		ifTrue: [ class := MsgPackRPCNotification ].
	array isArray
		ifFalse: [ Error signal: 'Was not array' ].
	^ class withAll: array! !

!MsgPackRPCMessage class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 20:56'!
new
	^ (super new: self messageSize)
		initialize;
		yourself! !

!MsgPackRPCMessage class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:46'!
withAll: anArray
	anArray size = self messageSize ifFalse:[Error signal: self name, ' must be 4 items long.'].
	^(super withAll: anArray) initialize.! !

MsgPackRPCMessage variableSubclass: #MsgPackRPCNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC'!

!MsgPackRPCNotification class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:47'!
messageSize 
	^3.! !

!MsgPackRPCNotification methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:49'!
initialize 
	super initialize.
	self methodName isString
		ifFalse: [ self methodName: self methodName asString ].! !

!MsgPackRPCNotification methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:38'!
isNotification
	^true.! !

!MsgPackRPCNotification methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:38'!
isRequest
	^false.! !

!MsgPackRPCNotification methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:38'!
isResponse
	^ false.! !

!MsgPackRPCNotification methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:47'!
methodName
	^self at: 2! !

!MsgPackRPCNotification methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:44'!
methodName: aString
	self at: 2 put: aString! !

MsgPackRPCMessage variableSubclass: #MsgPackRPCRequestResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC'!

MsgPackRPCRequestResponse variableSubclass: #MsgPackRPCRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC'!

!MsgPackRPCRequest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:22'!
initialize
	super initialize.
	self at: 2 put: 0.
	self parameters ifNil: [ self parameters: Array new ].
	self methodName isString
		ifFalse: [ self methodName: self methodName asString ]! !

!MsgPackRPCRequest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 22:55'!
initializeRequest
	self messageId ifNil:[self messageId: 0].
	self arguments ifNil:[self arguments: Array new].
	self methodName isString ifFalse:[self methodName: self methodName asString].! !

!MsgPackRPCRequest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:28'!
isRequest
	^ true.! !

!MsgPackRPCRequest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:27'!
isResponse
	^false.! !

!MsgPackRPCRequest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 21:23'!
methodName
	^ self at: 3.! !

!MsgPackRPCRequest methodsFor: 'accessing' stamp: 'PanuSuominen 11/10/2011 21:23'!
methodName: aString
	self at: 3 put: aString! !

!MsgPackRPCRequest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:21'!
parameters
	^self at: 4.! !

!MsgPackRPCRequest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:20'!
parameters: anArray 
	self at: 4 put: anArray.! !

!MsgPackRPCRequestResponse class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:51'!
messageSize
	^ 4! !

!MsgPackRPCRequestResponse methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 20:47'!
initialize
	super initialize.
	self messageId ifNil: [ self messageId: 0 ]! !

!MsgPackRPCRequestResponse methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 20:56'!
messageId
	^ self at: 1.! !

!MsgPackRPCRequestResponse methodsFor: 'accessing' stamp: 'PanuSuominen 11/14/2011 20:45'!
messageId: anInteger
	self at: 1 put: anInteger! !

MsgPackRPCRequestResponse variableSubclass: #MsgPackRPCResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC'!

!MsgPackRPCResponse methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 20:48'!
errorMessage
	^self at: 3.! !

!MsgPackRPCResponse methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:07'!
errorMessage: anObject
	self at: 3 put: anObject.
	self at: 4 put: nil.! !

!MsgPackRPCResponse methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 20:53'!
initialize 
	super initialize.
	self at: 2 put: 1.! !

!MsgPackRPCResponse methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:25'!
isRequest
	^ false! !

!MsgPackRPCResponse methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 20:53'!
isResponse
	^ true.! !

!MsgPackRPCResponse methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 20:58'!
result
	^self at: 4.! !

!MsgPackRPCResponse methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:07'!
result: anObject
	self at: 4 put: anObject.
	self at: 3 put: nil.
! !

!SmallInteger methodsFor: '*MsgPack' stamp: 'PanuSuominen 11/10/2011 19:51'!
messagePackOn: aStream
	self >= 0
		ifTrue: [ 
			self <= 127
				ifTrue: [ 
					MsgPack messagePackPositiveFixNum: self on: aStream.
					^ aStream ].
			self <= 255
				ifTrue: [ 
					MsgPack messagePackUint8: self on: aStream.
					^ aStream ].
			self <= 16rFFFF
				ifTrue: [ 
					MsgPack messagePackUint16: self on: aStream.
					^ aStream ].
			MsgPack messagePackUint32: self on: aStream.
			^ aStream ]
		ifFalse: [ 
			self >= -32
				ifTrue: [ 
					MsgPack messagePackNegativeFixNum: self on: aStream.
					^ aStream ].
			self >= -128
				ifTrue: [ 
					MsgPack messagePackInt8: self on: aStream.
					^ aStream ].
			self >= -32768
				ifTrue: [ 
					MsgPack messagePackInt16: self on: aStream.
					^ aStream ].
			MsgPack messagePackInt32: self on: aStream.
			^ aStream ]! !

ProtoObject subclass: #MsgPackProxyObject
	instanceVariableNames: 'definition map'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackProxyObject class methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 20:05'!
for: aMsgPackIDLMessage
	| proxy |
	proxy := self new.
	proxy setMsgPackIDLDefinition: aMsgPackIDLMessage.
	^ proxy! !

!MsgPackProxyObject class methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 21:58'!
messageUnpackFrom: aReadStream usingDefinition: aMsgPackIDLMessage
	| proxy array |
	array := MsgPack messageUnpackNext: aReadStream.
	proxy := self for: aMsgPackIDLMessage.
	array withIndexDo: [ :object :index| proxy at: index put: ((aMsgPackIDLMessage fieldAt: index) covertToType: object) ].
	^ proxy! !

!MsgPackProxyObject methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 19:30'!
at: index
	^ map at: index! !

!MsgPackProxyObject methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 19:30'!
at: index put: data
	map at: index put: data.! !

!MsgPackProxyObject methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 19:33'!
doesNotUnderstand: aMessage
	| fieldName fieldIndex |
	fieldName := aMessage selector last = $:
		ifTrue: [ aMessage selector allButLast ]
		ifFalse: [ aMessage selector ].
	fieldIndex := definition fieldIndexOf: fieldName.
	aMessage selector last = $:
		ifTrue: [ ^ self at: fieldIndex put: (aMessage arguments first) ]
		ifFalse: [ ^ self at: fieldIndex ]! !

!MsgPackProxyObject methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 19:31'!
initialize
	map := Dictionary new! !

!MsgPackProxyObject methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 21:12'!
messagePack
	| writeStream |
	writeStream := WriteStream on: Array new.
	self messagePackOn: writeStream.
	^ writeStream contents.! !

!MsgPackProxyObject methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 21:25'!
messagePackOn: aWriteStream
	| array |
	array := Array new: definition maxFieldIndex.
	definition fields do: [ :field | array at: field id put: (self at: field id) ].
	array messagePackOn: aWriteStream.! !

!MsgPackProxyObject methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 20:05'!
setMsgPackIDLDefinition: aMsgPackIDLMessage 
	definition := aMsgPackIDLMessage.! !

TestCase subclass: #MsgPackCodeGeneratorTest
	instanceVariableNames: 'generator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL-Generator-Tests'!

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 13:48'!
categoryForTesting
	^ self class category,'-GENERATED'.! !

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 13:49'!
clearTestingCategory
	Smalltalk organization removeCategoriesMatching: self categoryForTesting! !

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 14:14'!
generateFor: aMsgPackIDL
	aMsgPackIDL acceptVisitor: generator.! !

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 14:07'!
setUp
	generator := MsgPackCodeGenerator new.
	generator categoryName: self categoryForTesting.
	generator classPrefix: 'MsgPackTest'! !

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 15:33'!
tearDown
	self clearTestingCategory.! !

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:11'!
testAccessorGeneration
	| object list |
	self
		generateFor:
			(MsgPackIDLMessage new
				name: 'Message';
				addFieldNamed: 'field1' andTyped: MsgPackIDLMessageStringFieldType;
				yourself).
	object := (Smalltalk at: #MsgPackTestMessage) new.
	self assert: (object perform: #field1) isNil.
	object perform: #field1: with: 'jee'.
	self assert: (object perform: #field1) = 'jee'! !

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:13'!
testAccessorOfIntegerField
	| object list |
	self
		generateFor:
			(MsgPackIDLMessage new
				name: 'Message';
				addFieldNamed: 'field1' andTyped: MsgPackIDLMessageIntFieldType;
				yourself).
	object := (Smalltalk at: #MsgPackTestMessage) new.
	self assert: (object perform: #field1) isNil.
	object perform: #field1: with: 12.
	self assert: (object perform: #field1) = 12! !

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:13'!
testAccessorOfStringFieldConvertsDataToString
	| object list |
	self
		generateFor:
			(MsgPackIDLMessage new
				name: 'Message';
				addFieldNamed: 'field1' andTyped: MsgPackIDLMessageStringFieldType;
				yourself).
	object := (Smalltalk at: #MsgPackTestMessage) new.
	self assert: (object perform: #field1) isNil.
	object perform: #field1: with: 123.
	self assert: (object perform: #field1) = '123'! !

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 14:15'!
testClassCreation
	| class |
	self
		generateFor:
			(MsgPackIDLMessage new
				name: 'Message';
				yourself).
	class := Smalltalk at: #MsgPackTestMessage.
	self deny: class isNil! !

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:13'!
testClassFieldCreation
	| class |
	self
		generateFor:
			(MsgPackIDLMessage new
				name: 'Message';
				addFieldNamed: 'field1' andTyped: MsgPackIDLMessageStringFieldType;
				yourself).
	class := Smalltalk at: #MsgPackTestMessage.
	self deny: class isNil.
	self assert: (class allInstVarNames includes: #field1)! !

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:13'!
testClassPacking
	| object list |
	self
		generateFor:
			(MsgPackIDLMessage new
				name: 'Message';
				addFieldNamed: 'field1' andTyped: MsgPackIDLMessageStringFieldType;
				yourself).
	object := (Smalltalk at: #MsgPackTestMessage) new.
	self assert: (object perform: #field1) isNil.
	object perform: #field1: with: 'jee'.
	list := object messagePack messageUnpack.
	self assert: 1 == list size! !

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/12/2012 12:11'!
testClassUnpacking
	| object list |
	self
		generateFor:
			(MsgPackIDLMessage new
				name: 'Message';
				addFieldNamed: 'field1' andTyped: MsgPackIDLMessageStringFieldType;
				yourself).
	object := (Smalltalk at: #MsgPackTestMessage) messageUnpackFrom: ((Array with: 'jee') messagePack readStream).
	self assert: 'jee' = object field1.
"	self assert: (object perform: #field1) isNil.
	object perform: #field1: with: 'jee'.
	list := object messagePack messageUnpack.
	self assert: 1 == list size"! !

!MsgPackCodeGeneratorTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/2/2012 15:17'!
testEnumCreation
	| object list |
	self
		generateFor:
			(MsgPackIDLEnum new
				name: 'Enum';
				values: {'STRING' -> 0} asDictionary;
				yourself).
	self assert: 0 = ((Smalltalk at: #MsgPackTestEnum) perform: #STRING) value! !

TestCase subclass: #MsgPackIDLMessageFieldTypeTest
	instanceVariableNames: 'field'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL-Tests'!

!MsgPackIDLMessageFieldTypeTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 10:11'!
setUp
	field := MsgPackIDLMessageFieldType new.! !

!MsgPackIDLMessageFieldTypeTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 10:11'!
testConvertReturnsSelf
	| object |
	object := Object new.
	self assert: object == (field convert: object)! !

!MsgPackIDLMessageFieldTypeTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 10:12'!
testParseLiteralRetunsTheLiteral
	self assert: 'literal' = (field parseLiteral: 'literal').! !

!MsgPackIDLMessageFieldTypeTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 10:11'!
testResolveReturnsTheField
	self assert: field == (field resolve: MsgPackIDL new).! !

TestCase subclass: #MsgPackIDLTestBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL-Tests'!

MsgPackIDLTestBase subclass: #MsgPackIDLTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL-Tests'!

!MsgPackIDLTest methodsFor: 'tests - comments' stamp: 'PanuWetterstrand 10/16/2012 19:12'!
testCommentsAreIgnored
	self
		parse: '
		#Ignore this
		
		message Data{1: string address}
		
		'
		andDo: [:idl | self assert: 1 = idl definitionCount ].! !

!MsgPackIDLTest methodsFor: 'tests - enum' stamp: 'PanuSuominen 12/5/2011 12:32'!
testEnum
	self
		parse:
			'
enum Color {
  0: RED
  1: GREEN
  2: BLUE
}'
		andDo: [ :definitions | 
			| enumDefinition |
			enumDefinition := definitions enumNamed: 'Color'.
			self assert: 0 = (enumDefinition valueFor: #RED).
			self assert: 1 = (enumDefinition valueFor: #GREEN).
			self assert: 2 = (enumDefinition valueFor: #BLUE) ]! !

!MsgPackIDLTest methodsFor: 'tests - enum' stamp: 'PanuSuominen 12/5/2011 12:33'!
testEnumAsPartOfMessage
	self
		parse:
			'
enum Color {
  0: RED
  1: GREEN
  2: BLUE
}
message LightSource{
	0:Color color
	1:int magnitude
}
'
		andDo: [ :result | 
			| type |
			type := result typeNamed: 'LightSource'.
			self assert: (type fieldAt: 0) type isEnum.
			self assert: 0 = ((type fieldAt: 0) type valueFor: #RED) ]! !

!MsgPackIDLTest methodsFor: 'tests - message' stamp: 'PanuSuominen 12/5/2011 21:49'!
testNullableIntField
	self
		parse: 'message Data{1: int? number}'
		withDefinitionOf: 'Data'
		do: [ :messageDefinition | self assert: (messageDefinition fieldAt: 1) isNullable ]! !

!MsgPackIDLTest methodsFor: 'tests - message' stamp: 'PanuSuominen 12/5/2011 21:49'!
testNullableIntFieldNegativeCase
	self
		parse: 'message Data{1: int number}'
		withDefinitionOf: 'Data'
		do: [ :messageDefinition | self deny: (messageDefinition fieldAt: 1) isNullable ]! !

!MsgPackIDLTest methodsFor: 'tests - message' stamp: 'PanuWetterstrand 10/16/2012 22:25'!
testNullableReference
	self
		parse:
			'
			message Other {1: int id}
			message Node {
                   1: Other? name
               }'
		withDefinitionOf: 'Node'
		do: [ :messageDefinition | 
			| field |
			field := messageDefinition fieldAt: 1.
			self assert: field isNullable.
			self assert: 'name' = field name]! !

!MsgPackIDLTest methodsFor: 'tests - message' stamp: 'PanuSuominen 12/5/2011 21:49'!
testParsingAllBaseTypes
	self
		parse:
			'
message BaseTypes {
  1:byte testByte
  2:short testShort
  3:int testInt
  4:long testLong
  5:ubyte testUByte
  6:ushort testUShort
  7:uint testUInte
  8:ulong testULong
  9:float testFloat
  10:double testDouble
  11:bool testBool
  12:raw testRaw
  13:string testString
}'
		withDefinitionOf: 'BaseTypes'
		do: [ :messageDefinition | 
			self assert: (messageDefinition fieldAt: 1) type = MsgPackIDLMessageByteFieldType new.
			self assert: (messageDefinition fieldAt: 2) type = MsgPackIDLMessageShortFieldType new.
			self assert: (messageDefinition fieldAt: 3) type = MsgPackIDLMessageIntFieldType new.
			self assert: (messageDefinition fieldAt: 4) type = MsgPackIDLMessageLongFieldType new.
			self assert: (messageDefinition fieldAt: 5) type = MsgPackIDLMessageUByteFieldType new.
			self assert: (messageDefinition fieldAt: 6) type = MsgPackIDLMessageUShortFieldType new.
			self assert: (messageDefinition fieldAt: 7) type = MsgPackIDLMessageUIntFieldType new.
			self assert: (messageDefinition fieldAt: 8) type = MsgPackIDLMessageULongFieldType new.
			self assert: (messageDefinition fieldAt: 9) type = MsgPackIDLMessageFloatFieldType new.
			self assert: (messageDefinition fieldAt: 10) type = MsgPackIDLMessageDoubleFieldType new.
			self assert: (messageDefinition fieldAt: 11) type = MsgPackIDLMessageBoolFieldType new.
			self assert: (messageDefinition fieldAt: 12) type = MsgPackIDLMessageRawFieldType new.
			self assert: (messageDefinition fieldAt: 13) type = MsgPackIDLMessageStringFieldType new ]! !

!MsgPackIDLTest methodsFor: 'tests - message' stamp: 'PanuSuominen 12/5/2011 21:49'!
testParsingListFieldType
	self
		parse:
			'
message NumberList {
	1: list<int> numbers
}'
		withDefinitionOf: 'NumberList'
		do: [ :messageDefinition | 
			self assert: (messageDefinition fieldAt: 1) name = 'numbers'.
			self assert: (messageDefinition fieldAt: 1) type contentsType = MsgPackIDLMessageIntFieldType new ]! !

!MsgPackIDLTest methodsFor: 'tests - message' stamp: 'PanuSuominen 12/5/2011 21:49'!
testParsingMapFieldType
	self
		parse:
			'
message Data {
	1:map<int,string> values
}'
		withDefinitionOf: 'Data'
		do: [ :messageDefinition | 
			self assert: (messageDefinition fieldAt: 1) type keyType = MsgPackIDLMessageIntFieldType new.
			self assert: (messageDefinition fieldAt: 1) type valueType = MsgPackIDLMessageStringFieldType new ]! !

!MsgPackIDLTest methodsFor: 'tests - exception' stamp: 'PanuWetterstrand 10/15/2012 13:27'!
testParsingSimpleException
	self
		parse:
			'exception exception{
                   1: int number = 2}'
		withDefinitionOf: 'exception'
		do: [ :messageDefinition | 
			| field |
			self assert: messageDefinition isException.
			self deny: messageDefinition isMessage.
			field := messageDefinition fieldAt: 1.
			self assert: 'number' = field name.
			self assert: 2 = field literal ]! !

!MsgPackIDLTest methodsFor: 'tests - message' stamp: 'PanuSuominen 12/5/2011 21:49'!
testParsingSimpleIntMessageWithLiteral
	self
		parse:
			'message Data{
                   1: int number = 2}'
		withDefinitionOf: 'Data'
		do: [ :messageDefinition | 
			| field |
			field := messageDefinition fieldAt: 1.
			self assert: 'number' = field name.
			self assert: 2 = field literal ]! !

!MsgPackIDLTest methodsFor: 'tests - message' stamp: 'PanuWetterstrand 10/16/2012 22:23'!
testParsingSimpleMessage
	self
		parse: 'message Data{1: string address}'
		withDefinitionOf: 'Data'
		do: [ :messageDefinition | 
			| field |
			self assert: messageDefinition isMessage.
			self deny: messageDefinition isException.
			field := messageDefinition fieldAt: 1.
			self assert: 'address' = field name.
			self deny: field isNullable  ]! !

!MsgPackIDLTest methodsFor: 'tests - message' stamp: 'PanuSuominen 12/5/2011 21:49'!
testParsingSimpleMessageSuperClass
	self
		parse:
			'
message Shape{
	1: float area
}

message Square < Shape {
	2:float side
}
'
		withDefinitionOf: 'Square'
		do: [ :messageDefinition | 
			self assert: (messageDefinition fieldAt: 1) name = 'area'.
			self assert: (messageDefinition fieldAt: 2) name = 'side' ]! !

!MsgPackIDLTest methodsFor: 'tests - message' stamp: 'PanuWetterstrand 10/16/2012 22:24'!
testParsingSimpleMessageWithNullableReference
	self
		parse:
			'message Node {
                   1: string? address
               }'
		withDefinitionOf: 'Node'
		do: [ :messageDefinition | 
			| field |
			field := messageDefinition fieldAt: 1.
			self assert: field isNullable.
			self assert: 'address' = field name]! !

!MsgPackIDLTest methodsFor: 'tests - message' stamp: 'PanuSuominen 12/5/2011 21:49'!
testParsingSimpleMessageWithOptionalField
	self
		parse:
			'message Node {
                   1: optional string address
               }'
		withDefinitionOf: 'Node'
		do: [ :messageDefinition | 
			| field |
			field := messageDefinition fieldAt: 1.
			self assert: field isOptional.
			self assert: 'address' = field name ]! !

!MsgPackIDLTest methodsFor: 'tests - message' stamp: 'PanuSuominen 12/5/2011 21:49'!
testParsingSimpleMessageWithRequiredField
	self
		parse:
			'
message Person {
	1: required string lastName
	2: required string firtstName
	3: optional int age
}

message Contact{
	1: required Person person
	2: optional string address
}
'
		withDefinitionOf: 'Contact'
		do: [ :messageDefinition | 
			| field |
			field := messageDefinition fieldAt: 1.
			self assert: field isRequired.
			self assert: field type name = 'Person'.
			self assert: field type isMessage.
			self assert: 'age' = (field type fieldAt: 3) name ]! !

!MsgPackIDLTest methodsFor: 'tests - service' stamp: 'PanuWetterstrand 10/16/2012 10:17'!
testServiceTwoArguments
	self
		parse:
			'
service Service {
  void set(1: raw key, 2 : optional string? param2, 3: required byte value=2)
}'
		withDefinitionOf: 'Service'
		do: [ :service ||function|
			function := (service functionNamed:'set'). 
			self assert: function returnType = MsgPackIDLMessageVoidType new.
			].! !

!MsgPackIDLTest methodsFor: 'tests - service' stamp: 'PanuSuominen 12/6/2011 12:20'!
testSimpleService
	self
		parse:
			'
service Service {
  void set(1: raw key)
}'
		withDefinitionOf: 'Service'
		do: [ :service | 
			self assert: service name ='Service'.
			].! !

!MsgPackIDLTest methodsFor: 'tests - service' stamp: 'PanuWetterstrand 10/16/2012 22:03'!
testSimpleServiceReturningInt
	self
		parse:
			'
service Service {
  int set(1: raw key)
}'
		withDefinitionOf: 'Service'
		do: [ :service | 
			self assert: (service functionNamed: 'set') returnType = MsgPackIDLMessageIntFieldType new.
			].! !

!MsgPackIDLTest methodsFor: 'tests - service' stamp: 'PanuWetterstrand 10/16/2012 22:33'!
testSimpleServiceWithNullableReferenceReturnType

	self
		parse:
'service Stuff {
  Person? get(1: raw key)
}

message Person {
 1: int id
}
'
		withDefinitionOf: 'Stuff'
		do: [ :service | 	|function returnType |
				function :=  (service functionNamed: 'get').
			self assert: function canReturnNull.
			].! !

!MsgPackIDLTest methodsFor: 'tests - service' stamp: 'PanuWetterstrand 10/16/2012 22:16'!
testSimpleServiceWithReferenceReturnType
	self
		parse:
'service Service {
  Person get(1: raw key)
}

message Person {
 1: int id
}
'
		withDefinitionOf: 'Service'
		do: [ :service | 
			self assert: service name ='Service'.
			self assert: (service functionNamed: 'get') returnType = (service ownerDefinitions messageNamed:'Person').
			].! !

!MsgPackIDLTestBase methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 20:12'!
parse: aString andDo:anOneArgumentBlock
	^anOneArgumentBlock value: aString asMessagePackIDL! !

!MsgPackIDLTestBase methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 20:12'!
parse: idlString withDefinitionOf: typeName do: anOneArgumentBlock
	^ self
		parse: idlString
		andDo: [ :result | 
			| type |
			type := result typeNamed: typeName.
			self deny: type isNil.
			anOneArgumentBlock value: type ]! !

MsgPackIDLTestBase subclass: #MsgPackProxyObjectTest
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL-Tests'!

!MsgPackProxyObjectTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 21:11'!
objectFromMessage: aByteString
	object := (self parse: aByteString andDo: [ :msgPackIDL | msgPackIDL contents at: 1 ]) createObject.! !

!MsgPackProxyObjectTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 20:21'!
testObjectFromIDLMessage
	self
		objectFromMessage:
			'
message Person {
	1: string name
}
'.
	object name: 'jaska'.
	self assert: 'jaska' = object name! !

!MsgPackProxyObjectTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 21:49'!
testSimpleObjectDeserialization
	self
		parse:
			'
message Person {
	1: string name
}
'
		withDefinitionOf: 'Person'
		do: [ :definition | 
			| tmp |
			tmp := definition messageUnpack: ((Array with: 'blaah') messagePack).
			self assert: tmp name = 'blaah' ]! !

!MsgPackProxyObjectTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 21:28'!
testSimpleObjectSerialization
	self
		objectFromMessage:
			'
message Person {
	1: string name
}
'.
	object name: 'jaska'.
	self assert: ((object messagePack) messageUnpack at: 1) asString = 'jaska'! !

TestCase subclass: #MsgPackRPCClientTest
	instanceVariableNames: 'rpcClient writeStream readStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC-Tests'!

!MsgPackRPCClientTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:56'!
setUp
	writeStream := WriteStream on: Array new.
	readStream := ReadWriteStream on: Array new.
	rpcClient := MsgPackRPCClient new
		writeStream: writeStream;
		readStream: readStream;
		yourself.! !

!MsgPackRPCClientTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 10/26/2011 21:45'!
tearDown 
	rpcClient close.! !

!MsgPackRPCClientTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 22:17'!
testRequestIsSend
	| msg expectedResult result |
	[ result := rpcClient rpcCallMethod: 'metodi' withArgs: #() ] fork.
	self
		should: [ 
			[ 
			Processor yield.
			writeStream contents size = 0 ] whileTrue ]
		notTakeMoreThanMilliseconds: 500.
	msg := MsgPackRPCMessage messageUnpackFrom: writeStream contents readStream.
	self assert: msg isRequest.
	self assert: 'metodi' = msg methodName! !

!MsgPackRPCClientTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 22:32'!
testResponseIsReceived
	| msg expectedResult result semaphore |
	semaphore := Semaphore new.
	[ 
	result := rpcClient rpcCallMethod: 'metodi' withArgs: #().
	semaphore signal ] fork.
	self
		should: [ 
			[ 
			Processor yield.
			writeStream contents size = 0 ] whileTrue ]
		notTakeMoreThanMilliseconds: 500.
	msg := MsgPackRPCMessage messageUnpackFrom: writeStream contents readStream.
	MsgPackRPCResponse new
		messageId: msg messageId;
		result: expectedResult;
		messagePackOn: readStream.
	readStream position: 0.
	self should: [ semaphore wait ] notTakeMoreThanMilliseconds: 500.
	self assert: result = expectedResult! !

TestCase subclass: #MsgPackRPCMessageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC-Tests'!

!MsgPackRPCMessageTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 21:19'!
testNoticeParsingFromStream
	| unpacked packed |
	packed := MsgPackRPCNotification new
		methodName: 'asd123';
		yourself.
	unpacked := MsgPackRPCMessage messageUnpackFrom: packed messagePack readStream.
	self assert: packed methodName = unpacked methodName.
	self assert: unpacked isNotification! !

!MsgPackRPCMessageTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 21:12'!
testRequestParsingFromStream
	| unpacked packed |
	packed := MsgPackRPCRequest new.
	unpacked := MsgPackRPCMessage messageUnpackFrom: packed messagePack readStream.
	self assert: packed messageId = unpacked messageId.
	self assert: unpacked isRequest.! !

!MsgPackRPCMessageTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 21:12'!
testResponseParsingFromStream
	| unpacked packed |
	packed := MsgPackRPCResponse new.
	unpacked := MsgPackRPCMessage messageUnpackFrom: packed messagePack readStream.
	self assert: packed messageId = unpacked messageId.
	self assert: unpacked isResponse! !

TestCase subclass: #MsgPackRPCRequestResponseTest
	instanceVariableNames: 'msg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC-Tests'!

MsgPackRPCRequestResponseTest subclass: #MsgPackRPCNotificationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC-Tests'!

!MsgPackRPCNotificationTest class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:36'!
testedClass
	^ MsgPackRPCNotification! !

!MsgPackRPCNotificationTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:37'!
testMessageType
	self assert: msg isNotification.
	self deny: msg isRequest.
	self deny: msg isResponse! !

!MsgPackRPCNotificationTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:49'!
testMethodName
	msg methodName: 'asads'.
	self assert: self packAndUnpackResponse methodName = 'asads'! !

!MsgPackRPCRequestResponseTest class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:22'!
testedClass
	self subclassResponsibility.! !

!MsgPackRPCRequestResponseTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:18'!
packAndUnpackMessage
	^ MsgPack messageUnpackNext: msg messagePack readStream! !

!MsgPackRPCRequestResponseTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:24'!
packAndUnpackResponse
	^ self class testedClass messageUnpackFrom: (msg messagePack) readStream.! !

!MsgPackRPCRequestResponseTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:23'!
setUp
	msg := self class testedClass new.
! !

MsgPackRPCRequestResponseTest subclass: #MsgPackRPCRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC-Tests'!

!MsgPackRPCRequestTest class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:22'!
testedClass
	^ MsgPackRPCRequest! !

!MsgPackRPCRequestTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:19'!
testEmptyRequestHasZeroId
	self assert: msg messageId = 0.! !

!MsgPackRPCRequestTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:18'!
testMessageId
	msg messageId: 123.
	self assert: self packAndUnpackResponse messageId = 123.
	! !

!MsgPackRPCRequestTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:27'!
testMessageType
	self deny: msg isResponse.
	self assert: msg isRequest.
	self assert: 0 = (self packAndUnpackMessage at: 2)! !

!MsgPackRPCRequestTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:20'!
testMethodName
	msg methodName: 'methodName'.
	self assert: self packAndUnpackResponse methodName = 'methodName'! !

!MsgPackRPCRequestTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 22:22'!
testParameters
	| parameters |
	msg parameters: (Array with: 'parameter1').
	parameters := self packAndUnpackResponse parameters.
	self assert: (parameters at: 1) asString = 'parameter1'.
	self assert: (parameters size) = 1.
	! !

MsgPackRPCRequestResponseTest subclass: #MsgPackRPCResponseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC-Tests'!

!MsgPackRPCResponseTest class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:22'!
testedClass
	^ MsgPackRPCResponse! !

!MsgPackRPCResponseTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:09'!
testErrorAndResult
	msg errorMessage: Object new.
	msg result: Object new.
	self deny: msg result isNil.
	self assert: msg errorMessage isNil.
	msg errorMessage: Object new.
	self assert: msg result isNil.
	self deny: msg errorMessage isNil.
! !

!MsgPackRPCResponseTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:14'!
testErrorMessage
	msg errorMessage: 'blaah'.
	msg messageId: 123.
	self assert: self packAndUnpackResponse errorMessage asString ='blaah'.
	! !

!MsgPackRPCResponseTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:19'!
testMessageId
	msg messageId: 123.
	self assert: self packAndUnpackResponse messageId = 123.
	! !

!MsgPackRPCResponseTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:24'!
testMessageType
	self assert: msg isResponse.
	self deny: msg isRequest.
	self assert: 1 = (self packAndUnpackMessage at: 2)! !

!MsgPackRPCResponseTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/14/2011 21:15'!
testResult
	msg result: 'asdasd'.
	self assert: self packAndUnpackResponse result asString = 'asdasd'! !

TestCase subclass: #MsgPackerTest
	instanceVariableNames: 'random'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core-Tests'!

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 19:51'!
checkEncodingOf: anObject
	| stream decoded |
	stream := ReadWriteStream on: Array new.
	anObject messagePackOn: stream.
	decoded := MsgPack messageUnpackNext: stream reset.
	self assert: anObject = decoded! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 09:20'!
checkEncodingWith: count randomNegativeIntsEqualOrGreaterThan: minInt
	| randomInt encoded decoded |
	count timesRepeat: [
	randomInt := (self generateRandomIntEqualOrLessThan: minInt negated) negated.
	self checkEncodingOf: randomInt.  
	].! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 09:20'!
checkEncodingWith: count randomPositiveIntsEqualOrLessThan: maxInt
	| randomInt encoded decoded |
	count timesRepeat: [
	randomInt := self generateRandomIntEqualOrLessThan: maxInt.
	self checkEncodingOf: randomInt.  
	].! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 19:51'!
decoding: encodedArray shouldResult: resultObject
	| decoded |
	decoded := MsgPack messageUnpackNext: (ReadStream on: encodedArray).
	self assert: decoded = resultObject.! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 19:51'!
encoding: anObject shouldResult:  anArray 
	| result |
	result :=  (MsgPack messagePack: anObject).
	self assert:  anArray = result.
	self checkEncodingOf: anObject.  ! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 19:51'!
encoding: anObject shouldStart:  start
	| encoded |
	encoded :=  (MsgPack messagePack: anObject).
	self assert: (encoded beginsWith: start).  
	self checkEncodingOf: anObject.  ! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 08:54'!
generateRandomIntEqualOrLessThan: maxValue
	^random nextInt: maxValue.  ! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 10:14'!
setUp
	random := Random new.
	MsgPack initialize. "Make constants be what the code says"! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 12:40'!
testArrayBelow16Elements
	self encoding: #(1 2 3) shouldStart: #(2r10010011) asByteArray.
	! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/9/2011 09:34'!
testArrayBelow4294967296Elements
	| array expectedResult|
	array := OrderedCollection new.
	1 to: 65536 do: [:i| array add: (self generateRandomIntEqualOrLessThan: 255)].	
	expectedResult := (array inject: (WriteStream on: (ByteArray new:10)) into: [:stream :next| next messagePackOn: stream. stream]) contents.
	self encoding: array asArray shouldResult: #(16rDD 0  1 0 0) asByteArray, expectedResult.
! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/9/2011 09:34'!
testArrayBelow65536Elements
	| array expectedResult|
	array := OrderedCollection new.
	1 to: 16 do: [:i| array add: (self generateRandomIntEqualOrLessThan: 255)].	
	expectedResult := (array inject: (WriteStream on: (ByteArray new:10)) into: [:stream :next| next messagePackOn: stream. stream]) contents.
	self encoding: array asArray shouldResult: #(16rDC 00 16) asByteArray, expectedResult.
! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/7/2011 15:18'!
testDoube
	self encoding: 0.1 shouldResult: 16rCB3fb999999999999a asByteArray. 
	self encoding: 10.0 shouldResult: 16rCB4024000000000000 asByteArray. ! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/7/2011 14:48'!
testFalse
	self encoding: false shouldResult: (ByteArray with: 16rC2).! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/9/2011 10:34'!
testFloat
	self decoding: #(202 61 204 204 205) asByteArray shouldResult: (Float fromIEEE32Bit: 0.1 asIEEE32BitWord).
! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 10:32'!
testInt16
	self encoding: -129 shouldResult: (ByteArray with: 16rD1 with: 16rFF with: 16r7F).
	self encoding: -32768 shouldResult: (ByteArray with: 16rD1 with: 16r80 with: 16r00).			
! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 10:39'!
testInt32
	self encoding: -32769 shouldResult: (ByteArray with: 16rD2 with: 16rFF with: 16rFF with: 16r7F with: 16rFF).
	self encoding: -2147483648 shouldResult: (ByteArray with: 16rD2 with: 16r80  with: 16r00 with: 16r00 with: 16r00).			
! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 11:29'!
testInt64
	self encoding: -2147483649 shouldResult: #(16rD3 16rFF 16rFF 16rFF 16rFF 16r7F 16rFF 16rFF 16rFF) asByteArray.
	self encoding: -16r80<<56 shouldResult: #(16rD3 16r80 0 0 0 0 0 0 0) asByteArray.			
! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 19:51'!
testInt8
	| stream |
	self encoding: -33 shouldResult: (ByteArray with: 16rD0 with: 16rDF).
	self encoding: -127 shouldResult: (ByteArray with: 16rD0 with: 16r81).	
	self encoding: -128 shouldResult: (ByteArray with: 16rD0 with: 16r80).
	stream := ByteArray new: 2.
	MsgPack messagePackInt8: 5 on: stream writeStream.
	self assert: stream = #[16rD0 5].
	MsgPack messagePackInt8: 127 on: stream writeStream.
	self assert: stream = #[16rD0 127].
! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 13:40'!
testMapBelow16Elements
	|dictionary|
	dictionary := Dictionary new.
	dictionary at: 1 put: 2.
	dictionary at: 3 put: 4.
	self encoding: dictionary shouldResult: #(16r82 1 2 3 4) asByteArray.
	! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/9/2011 09:34'!
testMapBelow4294967296Elements
	| expectedResult dictionary stream |
	dictionary := Dictionary new.
	1 to: 65536 do: [ :i | dictionary at: i put: (self generateRandomIntEqualOrLessThan: 255) ].
	stream := WriteStream on: (ByteArray new: 65536*3).
	dictionary
		keysAndValuesDo: [ :key :value | 
			key messagePackOn: stream.
			value messagePackOn: stream ].
	expectedResult := stream contents.
	self encoding: dictionary shouldResult: #(16rDF 00 1 0 0) asByteArray , expectedResult! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/9/2011 09:34'!
testMapBelow65536Elements
	| expectedResult dictionary stream |
	dictionary := Dictionary new.
	1 to: 16 do: [ :i | dictionary at: i put: (self generateRandomIntEqualOrLessThan: 255) ].
	stream := WriteStream on: (ByteArray new: 10).
	dictionary
		keysAndValuesDo: [ :key :value | 
			key messagePackOn: stream.
			value messagePackOn: stream ].
	expectedResult := stream contents.
	self encoding: dictionary shouldResult: #(16rDE 00 16) asByteArray , expectedResult! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 09:19'!
testNegativeFixnum
	self encoding: -1 shouldResult: (ByteArray with: 2r11100000).
	self encoding: -32 shouldResult: (ByteArray with: 2r11111111).	
	self checkEncodingWith: 10 randomNegativeIntsEqualOrGreaterThan: -32.! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/7/2011 14:19'!
testNil
	self encoding: nil shouldResult: #(16rC0) asByteArray.
! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 08:54'!
testPositiveFixnum
	self encoding: 1 shouldResult: (ByteArray with: 2r00000001).
	self encoding: 127 shouldResult: (ByteArray with: 2r01111111).	
	self checkEncodingWith: 10 randomPositiveIntsEqualOrLessThan: 127.! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 10/26/2011 22:17'!
testRawBytesBelow32Bytes
	self encoding: #(1 2 3) asByteArray shouldResult: #(2r10100011 1 2 3) asByteArray.
	! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 12:35'!
testRawBytesBelow4294967296Bytes
	| array |
	array := ByteArray new: 65536.
	1 to: array size do: [:i| array at: i put: (self generateRandomIntEqualOrLessThan: 255)].	
	self encoding: array asByteArray shouldResult: #(16rDB 0 1 0 0) asByteArray, array.
	
! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 12:34'!
testRawBytesBelow65536Bytes
	| array |
	array := ByteArray new: 33.
	1 to: array size do: [:i| array at: i put: (self generateRandomIntEqualOrLessThan: 255)].	
	self encoding: array asByteArray shouldResult: #(16rDA 00 33) asByteArray, array.
	array := ByteArray new: 65535.
	1 to: array size do: [:i| array at: i put: (self generateRandomIntEqualOrLessThan: 255)].	
	self encoding: array asByteArray shouldResult: #(16rDA 16rFF 16rFF) asByteArray, array.
	
! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 09:21'!
testTrue
	self encoding: true shouldResult: (ByteArray with: 16rC3).
	self checkEncodingOf: true.  ! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/7/2011 21:40'!
testUint16
	self encoding: 256 shouldResult: (ByteArray with: 16rCD with: 2r00000001 with: 0).
	self encoding: 65535 shouldResult: (ByteArray with: 16rCD with: 16rFF with: 16rFF).! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/7/2011 14:08'!
testUint32
	self encoding: 16r10000 shouldResult: (ByteArray with: 16rCE with:0 with: 1 with: 0 with: 0).
	self encoding: 16rFFFFFFFE shouldResult: (ByteArray with: 16rCE with: 16rFF with: 16rFF with: 16rFF with:16rFE).	
	self encoding: 16rFFFFFFFF shouldResult: (ByteArray with: 16rCE with: 16rFF with: 16rFF with: 16rFF with: 16rFF).! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/7/2011 14:17'!
testUint64
	self encoding: 16r100000000 shouldResult: #(16rCF 0 0 0 16r01 0 0 0 0) asByteArray.
	self encoding: 16rFFFFFFFFFFFFFFFF shouldResult:  #(16rCF 16rFF 16rFF 16rFF 16rFF 16rFF 16rFF 16rFF 16rFF) asByteArray.
! !

!MsgPackerTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/7/2011 13:52'!
testUint8
	self encoding: 128 shouldResult: (ByteArray with: 16rCC with: 128).
	self encoding: 255 shouldResult: (ByteArray with: 16rCC with: 255).! !

!LargePositiveInteger methodsFor: '*MsgPack' stamp: 'PanuSuominen 11/10/2011 19:51'!
messagePackOn: aStream
	self > 16rFFFFFFFF
		ifFalse: [ 
			MsgPack messagePackUint32: self on: aStream. 
			^ aStream ].
	MsgPack messagePackUint64: self on: aStream. 
	^ aStream! !

!Dictionary methodsFor: '*MsgPack' stamp: 'PanuSuominen 6/9/2011 09:34'!
messagePackOn: aWriteStream
	(self size between: 0 and: 15)
		ifTrue: [ aWriteStream nextPut: (self size bitOr: 2r10000000) ]
		ifFalse: [ 
			(self size between: 16 and: 16rFFFF)
				ifTrue: [ 
					aWriteStream nextPut: 16rDE.
					aWriteStream uint16: self size ]
				ifFalse: [ 
					aWriteStream nextPut: 16rDF.
					aWriteStream uint32: self size ] ].
	self keysAndValuesDo: [ :key :value| key messagePackOn: aWriteStream. value messagePackOn: aWriteStream].
	^ aWriteStream! !

Object subclass: #MsgPack
	instanceVariableNames: ''
	classVariableNames: 'TypeTable'
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPack class methodsFor: 'initialization' stamp: 'PanuSuominen 6/9/2011 09:20'!
initialize
	super initialize.
	self populateTypeTable.! !

!MsgPack class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/9/2011 09:30'!
lookupType: aByte
	^(TypeTable at: aByte+1) ifNil:[MsgPackUnknownType signal: 'Uknown type ', aByte hex].! !

!MsgPack class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/9/2011 09:34'!
messagePack: anObject 
	| writeStream |
	writeStream := WriteStream on: ByteArray new.
	anObject messagePackOn: writeStream.
	^writeStream contents.! !

!MsgPack class methodsFor: 'float' stamp: 'PanuSuominen 11/10/2011 20:52'!
messagePackFloat: aFloat on: aWriteStream
	aWriteStream nextPut: 16rCB.
	4 to: 1 by: -1 do: [:i|
		aWriteStream nextPut: ((aFloat at: 1) digitAt:i).
	].
	4 to: 1 by: -1 do: [:i|
		aWriteStream nextPut: ((aFloat at: 2) digitAt:i).
	].! !

!MsgPack class methodsFor: 'signed integer' stamp: 'PanuSuominen 10/24/2011 22:15'!
messagePackInt16: aSmallInteger on: aWriteStream
	"Writes number from -32768 to 127."
	(aSmallInteger between: -32768 and: 32767)
		ifFalse: [ Error signal: aSmallInteger , ' is not in [-32768, 32767]' ].
	aWriteStream nextPut: 16rD1.
	aWriteStream int16: aSmallInteger.
! !

!MsgPack class methodsFor: 'signed integer' stamp: 'PanuSuominen 10/25/2011 16:06'!
messagePackInt32: aSmallInteger on: aWriteStream
	"Writes number from -65535 to 65534."

	(aSmallInteger between: -4294967295 and: 4294967294)
		ifFalse: [ Error signal: aSmallInteger asString , ' is not in [-65535, 65534]' ].
	aWriteStream nextPut: 16rD2.
	aWriteStream int32: aSmallInteger! !

!MsgPack class methodsFor: 'signed integer' stamp: 'PanuSuominen 10/25/2011 16:07'!
messagePackInt64: aLargeInteger on: aWriteStream
	| value |
	aLargeInteger digitLength > 9
		ifTrue: [ Error signal: 'Too big number for MessagePacked!!' ].
	aWriteStream nextPut: 16rD3.
	value := (aLargeInteger negated bitXor: 16rFFFFFFFFFFFFFFFF) + 1.
	aWriteStream nextPut: (value digitAt: 8).
	aWriteStream nextPut: (value digitAt: 7).
	aWriteStream nextPut: (value digitAt: 6).
	aWriteStream nextPut: (value digitAt: 5).
	aWriteStream nextPut: (value digitAt: 4).
	aWriteStream nextPut: (value digitAt: 3).
	aWriteStream nextPut: (value digitAt: 2).
	aWriteStream nextPut: (value digitAt: 1)! !

!MsgPack class methodsFor: 'signed integer' stamp: 'PanuSuominen 6/9/2011 10:55'!
messagePackInt8: aSmallInteger on: aWriteStream
	"Writes number from -128 to 127."

	(aSmallInteger between: -128 and: 127)
		ifFalse: [ Error signal: aSmallInteger , ' is not in [-128,127]' ].
	aWriteStream nextPut: 16rD0.
	aSmallInteger positive
		ifTrue: [ aWriteStream nextPut: aSmallInteger ]
		ifFalse: [ aWriteStream nextPut: (16rFF bitXor: aSmallInteger negated) + 1 ]! !

!MsgPack class methodsFor: 'fixed number' stamp: 'PanuSuominen 6/9/2011 10:50'!
messagePackNegativeFixNum: aSmallInteger on: aWriteStream
	"Writes number from -32 to -1."

	(aSmallInteger between: -32 and: -1)
		ifFalse: [ Error signal: aSmallInteger , ' is not in [-32,-1]' ].
	aWriteStream nextPut: (2r11100000 bitOr: aSmallInteger negated - 1)! !

!MsgPack class methodsFor: 'fixed number' stamp: 'PanuSuominen 6/9/2011 10:45'!
messagePackPositiveFixNum: aSmallInteger on: aWriteStream
	"Writes number from 0 to 127."
	(aSmallInteger between: 0 and: 127) ifFalse:[Error signal: aSmallInteger, ' is not in [0,127]'].
	aWriteStream nextPut: aSmallInteger.! !

!MsgPack class methodsFor: 'unsigned integer' stamp: 'PanuSuominen 6/9/2011 10:48'!
messagePackUint16: aSmallInteger on: aWriteStream
	"Writes number from 0 to 16rFFFF."
	(aSmallInteger between: 0 and: 16rFFFF)
		ifFalse: [ Error signal: aSmallInteger , ' is not in [0,65535]' ].
	aWriteStream nextPut: 16rCD.
	aWriteStream uint16: aSmallInteger! !

!MsgPack class methodsFor: 'unsigned integer' stamp: 'PanuSuominen 6/9/2011 10:49'!
messagePackUint32: anInteger on: aWriteStream
	"Writes number from 0 to 16rFFFFFFFF."

	(anInteger between: 0 and: 16rFFFFFFFF)
		ifFalse: [ Error signal: anInteger , ' is not in [0, 4294967295]' ].
	aWriteStream nextPut: 16rCE.
	aWriteStream uint32: anInteger! !

!MsgPack class methodsFor: 'unsigned integer' stamp: 'PanuSuominen 10/24/2011 22:23'!
messagePackUint64: aLargeInteger on: aWriteStream
	"Writes number from 0 to 16rFFFFFFFF."

	aLargeInteger digitLength > 9 ifTrue: [Error signal: 'Too big number for MessagePacked!!'].
	aWriteStream nextPut: 16rCF.
	aWriteStream nextPut: (aLargeInteger digitAt: 8).
	aWriteStream nextPut: (aLargeInteger digitAt: 7).
	aWriteStream nextPut: (aLargeInteger digitAt: 6).
	aWriteStream nextPut: (aLargeInteger digitAt: 5).
	aWriteStream nextPut: (aLargeInteger digitAt: 4).
	aWriteStream nextPut: (aLargeInteger digitAt: 3).
	aWriteStream nextPut: (aLargeInteger digitAt: 2).
	aWriteStream nextPut: (aLargeInteger digitAt: 1).
! !

!MsgPack class methodsFor: 'unsigned integer' stamp: 'PanuSuominen 6/9/2011 10:47'!
messagePackUint8: aSmallInteger on: aWriteStream
	"Writes number from 0 to 255."
	(aSmallInteger between: 0 and: 255) ifFalse:[Error signal: aSmallInteger, ' is not in [0,255]'].
	aWriteStream nextPut: 16rCC.
	aWriteStream nextPut: aSmallInteger.	
! !

!MsgPack class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 10/28/2011 10:38'!
messageUnpack: aByteArray
	^self messageUnpackNext: aByteArray readStream. 
! !

!MsgPack class methodsFor: 'collections' stamp: 'PanuSuominen 11/10/2011 20:03'!
messageUnpackArrayOfLength: length from: aReadStream
	| stream |
	stream := WriteStream on: (Array new: length  ).	
	length timesRepeat: [
		stream nextPut: (MsgPack messageUnpackNext: aReadStream). 
	].
	^stream contents.! !

!MsgPack class methodsFor: 'collections' stamp: 'PanuSuominen 11/10/2011 20:04'!
messageUnpackByteArrayOfLength: length from: aReadStream
	^ (aReadStream next: length) asByteArray! !

!MsgPack class methodsFor: 'collections' stamp: 'PanuSuominen 11/10/2011 20:03'!
messageUnpackDictionaryOfLength: length from: aReadStream
	| dictionary |
	dictionary := Dictionary new: length.
	length timesRepeat: [|key value|		
		key := (MsgPack messageUnpackNext: aReadStream). 
		value := (MsgPack messageUnpackNext: aReadStream). 
		dictionary at: key put: value.
	].
	^dictionary.! !

!MsgPack class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:33'!
messageUnpackDoubleFrom: aReadStream
	| double |
	double := Float one.
	double at: 1 put: aReadStream uint32.
	double at: 2 put: aReadStream uint32.
	^double
! !

!MsgPack class methodsFor: 'float' stamp: 'PanuSuominen 11/10/2011 20:34'!
messageUnpackFloatFrom: aReadStream
	^ Float fromIEEE32Bit: aReadStream uint32! !

!MsgPack class methodsFor: 'signed integer' stamp: 'PanuSuominen 11/10/2011 20:36'!
messageUnpackInt16From: aReadStream
	^ aReadStream int16! !

!MsgPack class methodsFor: 'signed integer' stamp: 'PanuSuominen 11/10/2011 20:36'!
messageUnpackInt32From: aReadStream
	^ aReadStream int32! !

!MsgPack class methodsFor: 'signed integer' stamp: 'PanuSuominen 11/10/2011 20:37'!
messageUnpackInt64From: aReadStream
	| hi lo value |
	hi := aReadStream uint32.
	lo := aReadStream uint32.
	value := (hi << 32) + lo.
	value >= 9223372036854775808
		ifTrue: [ ^ ((16rFFFFFFFFFFFFFFFF bitXor: value) + 1) negated ].
	^ value! !

!MsgPack class methodsFor: 'signed integer' stamp: 'PanuSuominen 11/10/2011 20:37'!
messageUnpackInt8From: aReadStream
	| byte |
	byte := aReadStream next.
	byte > 16r7F
		ifTrue: [ ^ ((16rFF bitXor: byte) + 1) negated ].
	^ byte! !

!MsgPack class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/8/2011 09:51'!
messageUnpackNext: aReadStream
	| type |
	type:= self readTypeFrom: aReadStream.
	^self readObjectOfType: type from: aReadStream.! !

!MsgPack class methodsFor: 'unsigned integer' stamp: 'PanuSuominen 11/10/2011 20:38'!
messageUnpackUInt16From: aReadStream
	^ aReadStream uint16! !

!MsgPack class methodsFor: 'unsigned integer' stamp: 'PanuSuominen 11/10/2011 20:38'!
messageUnpackUInt32From: aReadStream
	^ aReadStream uint32! !

!MsgPack class methodsFor: 'unsigned integer' stamp: 'PanuSuominen 11/10/2011 20:39'!
messageUnpackUInt64From: aReadStream
	| hi lo |
	hi := aReadStream uint32.
	lo := aReadStream uint32.
	^ (hi << 32) + lo! !

!MsgPack class methodsFor: 'unsigned integer' stamp: 'PanuSuominen 11/10/2011 20:39'!
messageUnpackUInt8From: aReadStream
	^ aReadStream next! !

!MsgPack class methodsFor: 'initialization' stamp: 'PanuSuominen 11/10/2011 20:41'!
populateTypeTable
	"Creates type table that is used to lookup correct handler for type read from a stream"
	TypeTable := Array new: 256.
	16r00 to: 16r7F do: [ :i | TypeTable at: i + 1 put: (MsgPackFixedValueType value: i) ].	"0 to 127"
	16r80 to: 16r8F do: [ :i | TypeTable at: i + 1 put: (MsgPackFixedLengthMapType length: i - 16r80) ].	"map lengths from 0 to 15"
	16r90 to: 16r9F do: [ :i | TypeTable at: i + 1 put: (MsgPackFixedLengthElementArrayType length: i - 16r90) ].	"array lengths from 0 to 15"
	16rA0 to: 16rBF do: [ :i | TypeTable at: i + 1 put: (MsgPackFixedLengthByteArrayType length: i - 16rA0) ].	"lengths from 0 to 31"
	16rE0 to: 16rFF do: [ :i | TypeTable at: i + 1 put: (MsgPackFixedValueType value: ((i bitAnd: 2r0011111) + 1) negated) ].	"-32 to -1"
	TypeTable at: 16rC0 + 1 put: (MsgPackFixedValueType value: nil).
	TypeTable at: 16rC2 + 1 put: (MsgPackFixedValueType value: false).
	TypeTable at: 16rC3 + 1 put: (MsgPackFixedValueType value: true).		
	TypeTable at: 16rCA + 1 put: (MsgPackFloatType new).		
	TypeTable at: 16rCB + 1 put: MsgPackDoubleType new.
	TypeTable at: 16rCC + 1 put: MsgPackUInt8Type new.
	TypeTable at: 16rCD + 1 put: MsgPackUInt16Type new.
	TypeTable at: 16rCE + 1 put: MsgPackUInt32Type new.
	TypeTable at: 16rCF + 1 put: MsgPackUInt64Type new.
	TypeTable at: 16rD0 + 1 put: MsgPackInt8Type new.
	TypeTable at: 16rD1 + 1 put: MsgPackInt16Type new.
	TypeTable at: 16rD2 + 1 put: MsgPackInt32Type new.
	TypeTable at: 16rD3 + 1 put: MsgPackInt64Type new.
	TypeTable at: 16rDA + 1 put: MsgPackByteArrayInt16Type new.
	TypeTable at: 16rDB + 1 put: MsgPackByteArrayInt32Type new.
	TypeTable at: 16rDC + 1 put: MsgPackElementArrayInt16Type new.
	TypeTable at: 16rDD + 1 put: MsgPackElementArrayInt32Type new.
	TypeTable at: 16rDE + 1 put: MsgPackMapUInt16Type new.
	TypeTable at: 16rDF + 1 put: MsgPackMapUInt32Type new! !

!MsgPack class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/7/2011 22:02'!
readObjectOfType: type from: aReadStream
	^type messageUnpackFrom: aReadStream.  ! !

!MsgPack class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/7/2011 21:52'!
readTypeFrom: aReadStream
	| typeByte | 
	typeByte := aReadStream next.
	^self lookupType: typeByte.! !

Object subclass: #MsgPackCodeGenerator
	instanceVariableNames: 'categoryName classPrefix currentClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL-Generator'!

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 13:43'!
categoryName
	^ categoryName! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 13:23'!
categoryName: aString
	categoryName := aString.! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 13:46'!
classPrefix
	^ classPrefix! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 13:23'!
classPrefix: aString 
	classPrefix := aString.! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 13:28'!
createAccessorsFor: aMSGPackIDLMessageField
	| name |
	name := aMSGPackIDLMessageField name.
	currentClass compile: (self generateStringGetterNamed: name) classified: #accessors.
	currentClass compile: (self generateStringSetterNamed: name) classified: #accessors! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 13:29'!
createClassForMessage: aMsgPackIDLMessage
	^ currentClass := Object
		subclass: (self classPrefix , aMsgPackIDLMessage name) asSymbol
		instanceVariableNames: (' ' join: aMsgPackIDLMessage fieldNames)
		classVariableNames: ''
		poolDictionaries: ''
		category: self categoryName! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/12/2012 12:08'!
createCodeForMessage: aMsgPackIDLMessage
	self createClassForMessage: aMsgPackIDLMessage.
	self createPackingMethodsForFields: aMsgPackIDLMessage fields.
	self createUnpackingMethodsForFields: aMsgPackIDLMessage fields.! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:19'!
createGeneralAccessorsForField: aMsgPackIDLMessageField
	| name |
	name := aMsgPackIDLMessageField name.
	currentClass compile: (self generateGetterNamed: name) classified: #accessors.
	currentClass compile: (self generateSetterNamed: name) classified: #accessors! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 13:30'!
createPackingMethodsForFields: fields
	currentClass compile: (self generateMessagePackingMethod: fields) classified: 'serialization'.! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/12/2012 12:07'!
createUnpackingMethodsForFields: fields
	currentClass compile: (self generateMessageUnpackingMethod: fields) classified: 'serialization'.
	currentClass class compile: 'messageUnpackFrom: aReadStream
	^ self new messageUnpackFrom: aReadStream; yourself.
	'! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 15:12'!
generateGetterNamed: name
	^ name , String cr , '    ^ ' , name , '.'! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 15:30'!
generateMessagePackingMethod: fields
	| maxFieldIndex |
	maxFieldIndex := fields inject: 0 into: [ :maxId :field | maxId max: field id ].
      ^ 'messagePackOn: aWriteStream
      | array |
      array := Array new: ' , maxFieldIndex asString , '.' , String cr
		,
			(String cr join: (fields collect: [ :field | '      array at:' , field id asString , ' put: self ' , field name , '.' ]))
		, String cr, '      array messagePackOn: aWriteStream.'! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/12/2012 12:10'!
generateMessageUnpackingMethod: fields
	| maxFieldIndex |
	maxFieldIndex := fields inject: 0 into: [ :maxId :field | maxId max: field id ].
	^ 'messageUnpackFrom: aReadStream
      | array |	
      array := MsgPack messageUnpackNext: aReadStream.
' , (String cr join: (fields collect: [ :field | '     self ' , field name , ': (array at: ' , (field id) asString, ' ).' ]))! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:16'!
generateSetterNamed: name
	^ name , ': value' , String cr ,'    ', name , ' := value.'! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 15:02'!
generateStringGetterNamed: name
	^ self generateGetterNamed: name.! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 15:12'!
generateStringSetterNamed: name
	^ name , ': value' , String cr ,'    ', name , ' := value asString.'! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/2/2012 15:23'!
visitEnum: aMsgPackIDLEnum
	currentClass := Object
		subclass: (self classPrefix , aMsgPackIDLEnum name) asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self categoryName.
	aMsgPackIDLEnum
		nameAndValuesDo: [ :name :literal | |enumClass|
			enumClass := currentClass
				subclass: (self classPrefix , aMsgPackIDLEnum name, name asCapitalizedPhrase) asSymbol				
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: self categoryName.
				enumClass class compile: 'value ', String cr , '      ^ ' , literal asString
				 ].
	aMsgPackIDLEnum
		nameAndValuesDo: [ :name :literal | currentClass class compile: name , String cr , '      ^ ' , self classPrefix, aMsgPackIDLEnum name , name asCapitalizedPhrase ]! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/2/2012 14:31'!
visitEnumField: aMsgPackIDLMessageField 
	self createGeneralAccessorsForField: aMsgPackIDLMessageField.! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:19'!
visitIntField: aMsgPackIDLMessageField 
	self createGeneralAccessorsForField: aMsgPackIDLMessageField.! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:19'!
visitListField: aMsgPackIDLMessageField 
	self createGeneralAccessorsForField: aMsgPackIDLMessageField.	! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 13:44'!
visitMessage: aMsgPackIDLMessage
	self createCodeForMessage: aMsgPackIDLMessage.! !

!MsgPackCodeGenerator methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:08'!
visitStringField: aMSGPackIDLMessageField
	| name |
	name := aMSGPackIDLMessageField name.
	currentClass compile: (self generateStringGetterNamed: name) classified: #accessors.
	currentClass compile: (self generateStringSetterNamed: name) classified: #accessors! !

Object subclass: #MsgPackIDL
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDL class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/2/2011 16:34'!
parse: aByteString 
	^self new parse: aByteString! !

!MsgPackIDL methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/2/2012 14:58'!
acceptVisitor: aMsgPackIDLVisitor
	self messages do: [ :message | message acceptVisitor: aMsgPackIDLVisitor ].
	self enums do: [ :enum | enum acceptVisitor: aMsgPackIDLVisitor ]! !

!MsgPackIDL methodsFor: 'parsing' stamp: 'PanuWetterstrand 10/16/2012 15:56'!
commentLineParser
	^ (#space asParser star, $# asParser, #newline asParser negate star, #newline asParser star) ==> [ :m | 'KOMMENTTI ' , m third ]! !

!MsgPackIDL methodsFor: 'accessing' stamp: 'PanuSuominen 12/3/2011 13:24'!
contents
	^ contents! !

!MsgPackIDL methodsFor: 'accessing' stamp: 'PanuSuominen 12/3/2011 13:25'!
contents: anObject
	contents := anObject! !

!MsgPackIDL methodsFor: 'accessing' stamp: 'PanuWetterstrand 10/16/2012 19:12'!
definitionCount
	^ contents size! !

!MsgPackIDL methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 21:40'!
definitionNamed: aString
	^ (self contents select: [ :c | c name = aString ])
		ifNotEmpty: [ :nonEmptyArray | nonEmptyArray anyOne ]
		ifEmpty: [ nil ]! !

!MsgPackIDL methodsFor: 'parsing' stamp: 'PanuSuominen 12/6/2011 11:58'!
enumDefinition
	^ ('enum' asParser , self nameDefinition , (${ asParser trim: #blank asParser | #newline asParser)
		,
			(self enumValue
				delimitedBy: (#newline asParser | #blank asParser) plus) , $} asParser trimBlanks)
		==> [ :m | 
			MsgPackIDLEnum new
				name: m second;
				values: (m fourth reject: #isArray) asDictionary
				yourself ]! !

!MsgPackIDL methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 12:13'!
enumNamed: aByteString
	^ (self enums select: [ :enum | enum name = aByteString ])
		ifEmpty: [ nil ]
		ifNotEmpty: [ :nonEmptyArray | nonEmptyArray anyOne ]! !

!MsgPackIDL methodsFor: 'parsing' stamp: 'PanuSuominen 12/5/2011 12:19'!
enumValue
	^ (#digit asParser plus flatten , $: asParser trimBlanks , #word asParser plus flatten trimBlanks)
		==> [ :v | v third asSymbol -> v first asInteger ]! !

!MsgPackIDL methodsFor: 'accessing' stamp: 'PanuSuominen 12/5/2011 12:07'!
enums
	^contents select: #isEnum! !

!MsgPackIDL methodsFor: 'parsing' stamp: 'PanuWetterstrand 10/15/2012 13:30'!
exceptionAndMessageDefinition
	^ (('exception' asParser ==> [ :v | MsgPackIDLException ]) | ('message' asParser ==> [ :v | MsgPackIDLMessage ])
		, self nameDefinition , ($< asParser trimBlanks , self nameDefinition) optional
		, (${ asParser trim: #blank asParser | #newline asParser)
		, (self fieldDefinition delimitedBy: (#newline asParser | #blank asParser) plus) , $} asParser trimBlanks)
		==> [ :m | 
			m first new
				name: m second;
				ownerDefinitions: self;
				superClassName: (m third ifNotNil: [ :nonNil | nonNil second ]);
				fields: (m fifth reject: #isCollection);
				yourself ]! !

!MsgPackIDL methodsFor: 'parsing' stamp: 'PanuSuominen 12/6/2011 11:59'!
fieldDefinition
	^ (#digit asParser plus flatten , $: asParser trimBlanks
		, ('optional' asParser ==> [ :v | true ] | ('required' asParser ==> [ :v | false ])) optional trimBlanks
		, self fieldType, $? asParser optional,  self nameDefinition
		, ($= asParser trimBlanks , #digit asParser plus flatten trimBlanks) optional)
		==> [ :fieldLine | 
			MsgPackIDLMessageField new
				id: fieldLine first;
				name: fieldLine sixth;
				ownerDefinitions: self;
				optional: (fieldLine third ifNotNil: [ :v | v ] ifNil: [ false ]);
				type: fieldLine fourth;
				nullable: fieldLine fifth isNil not;
				literal: (fieldLine seventh ifNotNil: [ :literalPart | literalPart second ]);
				yourself ]! !

!MsgPackIDL methodsFor: 'parsing' stamp: 'PanuWetterstrand 10/16/2012 10:06'!
fieldType
	| typeName |
	typeName := PPUnresolvedParser new.
	typeName
		def:
			(PPChoiceParser
				withAll:
					(Array
						with:
							('list<' asParser , typeName , $> asParser)
								==> [ :v | 
									MsgPackIDLMessageListFieldType new
										contentsType: v second;
										yourself ]
						with:
							('map<' asParser , typeName , $, asParser , typeName , $> asParser)
								==> [ :v | 
									MsgPackIDLMessageMapFieldType new
										keyType: v second;
										valueType: v fourth;
										yourself ]
						with:
							#word asParser plus flatten trimBlanks
								==> [ :s | 
									MsgPackIDLMessageReferenceFieldType new
										referencedTypeName: s;
										yourself ])).
	^ typeName! !

!MsgPackIDL methodsFor: 'parsing' stamp: 'PanuWetterstrand 10/16/2012 22:36'!
functionDefinition
	^ (('void' asParser ==> [ :v | MsgPackIDLMessageVoidType new]) / self fieldType, $? asParser optional, self nameDefinition , $( asParser
		, (self fieldDefinition separatedBy: ($, asParser trim: #blank asParser | #newline asParser)) , $) asParser trimBlanks)
		==> [ :v | 
			MsgPackIDLFunction new
				name: v third;
				ownerDefinitions: self;
				canReturnNull:  (v second ifNotNil: [ :nullableFlag | true ] ifNil: [ false ]);
				returnType: v first;
				yourself ]! !

!MsgPackIDL methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 13:44'!
generateToCategory: categoryName withPrefix: prefix
	self
		acceptVisitor:
			(MsgPackCodeGenerator new
				categoryName: categoryName;
				classPrefix: prefix;
				yourself)! !

!MsgPackIDL methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 12:06'!
messageNamed: aString
	^ (self messages select:[:m| m name = aString]) ifNotEmpty:[:nonEmpty| nonEmpty anyOne] ifEmpty:[nil].! !

!MsgPackIDL methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 12:07'!
messages
	^(contents select: #isMessage)! !

!MsgPackIDL methodsFor: 'parsing' stamp: 'PanuSuominen 12/6/2011 11:58'!
nameDefinition
	^ #word asParser plus flatten trimBlanks! !

!MsgPackIDL methodsFor: 'parsing' stamp: 'PanuWetterstrand 10/16/2012 19:18'!
parse: aByteString
	| parseResult |
	parseResult := (Array
		with: ((#space asParser plus trim: #newline asParser) answer: nil)
		with: ((self commentLineParser trim: #newline asParser) answer: nil)
		with: (self exceptionAndMessageDefinition trim: #newline asParser)
		with: (self serviceDefinition trim: #newline asParser)
		with: (self enumDefinition trim: #newline asParser)) asChoiceParser plus end
		==> [ :t | 
			self
				contents: (t select: [ :definition | definition isNil not]);
				yourself ] parse: aByteString.
	parseResult isPetitFailure
		ifTrue: [ 
			Error
				signal:
					parseResult asString , ' ''' , (aByteString copyFrom: (parseResult position - 20 max: 1) to: parseResult position) , '_'
						, (aByteString copyFrom: parseResult position + 1 to: (parseResult position + 20 min: aByteString size)) , '''' ].
	self resolveTypes! !

!MsgPackIDL methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 11:01'!
resolveTypes
	contents do:[:c| c resolveTypes].! !

!MsgPackIDL methodsFor: 'parsing' stamp: 'PanuSuominen 12/6/2011 13:10'!
serviceDefinition
	^ ('service' asParser , self nameDefinition , ($: asParser , #digit asParser plus) optional
		, (${ asParser trim: #blank asParser | #newline asParser)
		, (self functionDefinition delimitedBy: (#newline asParser | #blank asParser) plus) , $} asParser trimBlanks)
		==> [ :v | 
			MsgPackIDLService new
				ownerDefinitions: self;
				name: v second;
				functions: (v fifth reject: #isArray);
				yourself ]! !

!MsgPackIDL methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 21:40'!
typeNamed: aString
	^ MsgPackIDLMessageFieldType fieldTypes
		at: aString
		ifPresent: [ :c | c new ]
		ifAbsent: [ self definitionNamed: aString ]! !

Object subclass: #MsgPackIDLMessageFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageFieldType subclass: #MsgPackIDLMessageBaseFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageBaseFieldType class
	instanceVariableNames: 'instance'!

MsgPackIDLMessageBaseFieldType class
	instanceVariableNames: 'instance'!

!MsgPackIDLMessageBaseFieldType class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 11:19'!
isAbstract
	^self name = MsgPackIDLMessageBaseFieldType name.! !

!MsgPackIDLMessageBaseFieldType class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 09:58'!
new
	^ instance ifNil:[instance := self basicNew initialize;yourself].! !

!MsgPackIDLMessageBaseFieldType class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/3/2011 20:55'!
typeName
	^((self name allButFirst: 17) allButLast: 9) asLowercase.! !

MsgPackIDLMessageBaseFieldType subclass: #MsgPackIDLMessageBoolFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageBaseFieldType subclass: #MsgPackIDLMessageNumberFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageNumberFieldType subclass: #MsgPackIDLMessageByteFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageNumberFieldType subclass: #MsgPackIDLMessageDoubleFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageNumberFieldType subclass: #MsgPackIDLMessageFloatFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageNumberFieldType subclass: #MsgPackIDLMessageIntFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageIntFieldType class
	instanceVariableNames: 'Instance'!

MsgPackIDLMessageIntFieldType class
	instanceVariableNames: 'Instance'!

!MsgPackIDLMessageIntFieldType class methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:14'!
acceptVisitor: aMsgPackIDLVisitor whileVisitingField: aMsgPackIDLMessageField
	aMsgPackIDLVisitor visitIntField: aMsgPackIDLMessageField.! !

MsgPackIDLMessageNumberFieldType subclass: #MsgPackIDLMessageLongFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDLMessageNumberFieldType class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 11:20'!
isAbstract
	^self name = MsgPackIDLMessageNumberFieldType name.! !

!MsgPackIDLMessageNumberFieldType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 10:03'!
parseLiteral: aString
	^ aString asInteger.! !

MsgPackIDLMessageNumberFieldType subclass: #MsgPackIDLMessageShortFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageNumberFieldType subclass: #MsgPackIDLMessageUByteFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageNumberFieldType subclass: #MsgPackIDLMessageUIntFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageNumberFieldType subclass: #MsgPackIDLMessageULongFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageNumberFieldType subclass: #MsgPackIDLMessageUShortFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageBaseFieldType subclass: #MsgPackIDLMessageRawFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageBaseFieldType subclass: #MsgPackIDLMessageStringFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDLMessageStringFieldType class methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:03'!
acceptVisitor: aMsgPackIDLVisitor whileVisitingField: aMsgPackIDLMessageField
	aMsgPackIDLVisitor visitStringField: aMsgPackIDLMessageField.
	! !

!MsgPackIDLMessageStringFieldType methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 21:56'!
convert: anObject
	^ anObject asString.! !

!MsgPackIDLMessageFieldType class methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:03'!
acceptVisitor: aMsgPackIDLVisitor whileVisitingField: aMsgPackIDLMessageField
	"I am responsible for calling correct visitor for the field type. The actual field is my second parameter."
	self subclassResponsibility ! !

!MsgPackIDLMessageFieldType class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 11:20'!
baseTypes
	^((MsgPackIDLMessageBaseFieldType allSubclasses reject: #isAbstract) collect:[:c| c typeName -> c]) asDictionary! !

!MsgPackIDLMessageFieldType class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/3/2011 18:56'!
fieldTypes
	^ self baseTypes.! !

!MsgPackIDLMessageFieldType methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:03'!
acceptVisitor: aMsgPackIDLVisitor whileVisitingField: aMsgPackIDLMessageField
	self class acceptVisitor: aMsgPackIDLVisitor whileVisitingField: aMsgPackIDLMessageField

	! !

!MsgPackIDLMessageFieldType methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 09:42'!
convert: anObject
	"Converts given object to be the defined type. Conversion is necessary if the class of the unpacked object differs from
	what the class should be. For example string type is found from MsgPack IDL, but MSgPack actually encodes
	strings as raw data. Thus after unpacking it is not clear if wanted type is actually a ByteArray or String."
	
	^ anObject! !

!MsgPackIDLMessageFieldType methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 09:45'!
parseLiteral: aString
 	"I parse the given string to fit my type."
	^ aString! !

!MsgPackIDLMessageFieldType methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 09:48'!
resolve: aMsgPackIDLDefinitions
	"I return the actual field type from the given definitions. I should also resolve types that I contain. For normal types I always return myself"
	^self! !

MsgPackIDLMessageFieldType subclass: #MsgPackIDLMessageListFieldType
	instanceVariableNames: 'contentsType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDLMessageListFieldType class methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:17'!
acceptVisitor: aMsgPackIDLVisitor whileVisitingField: aMsgPackIDLMessageField
	aMsgPackIDLVisitor visitListField: aMsgPackIDLMessageField.! !

!MsgPackIDLMessageListFieldType methodsFor: 'accessing' stamp: 'PanuSuominen 12/3/2011 20:22'!
contentsType
	^ contentsType! !

!MsgPackIDLMessageListFieldType methodsFor: 'accessing' stamp: 'PanuSuominen 12/3/2011 20:22'!
contentsType: anObject
	contentsType := anObject! !

!MsgPackIDLMessageListFieldType methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 09:50'!
resolve: aMsgPackIDLDefinitions
	self resolveContentsType: aMsgPackIDLDefinitions.
	^ self! !

!MsgPackIDLMessageListFieldType methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 09:50'!
resolveContentsType: aMsgPackIDLDefinitions
	self contentsType: (self contentsType resolve: aMsgPackIDLDefinitions)! !

MsgPackIDLMessageFieldType subclass: #MsgPackIDLMessageMapFieldType
	instanceVariableNames: 'keyType valueType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDLMessageMapFieldType methodsFor: 'accessing' stamp: 'PanuSuominen 12/3/2011 20:40'!
keyType
	^ keyType! !

!MsgPackIDLMessageMapFieldType methodsFor: 'accessing' stamp: 'PanuSuominen 12/3/2011 20:40'!
keyType: anObject
	keyType := anObject! !

!MsgPackIDLMessageMapFieldType methodsFor: 'accessing' stamp: 'PanuWetterstrand 10/16/2012 09:50'!
resolve: aMsgPackIDLDefinitions
	self resolveKeyType: aMsgPackIDLDefinitions.
	self resolveValueType: aMsgPackIDLDefinitions.
	^ self! !

!MsgPackIDLMessageMapFieldType methodsFor: 'accessing' stamp: 'PanuWetterstrand 10/16/2012 09:49'!
resolveKeyType: aMsgPackIDLDefinitions
	self keyType: (self keyType resolve: aMsgPackIDLDefinitions)! !

!MsgPackIDLMessageMapFieldType methodsFor: 'accessing' stamp: 'PanuWetterstrand 10/16/2012 09:50'!
resolveValueType: aMsgPackIDLDefinitions
	self valueType: (self valueType resolve: aMsgPackIDLDefinitions)! !

!MsgPackIDLMessageMapFieldType methodsFor: 'accessing' stamp: 'PanuSuominen 12/3/2011 20:40'!
valueType
	^ valueType! !

!MsgPackIDLMessageMapFieldType methodsFor: 'accessing' stamp: 'PanuSuominen 12/3/2011 20:40'!
valueType: anObject
	valueType := anObject! !

MsgPackIDLMessageFieldType subclass: #MsgPackIDLMessageReferenceFieldType
	instanceVariableNames: 'referencedTypeName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDLMessageReferenceFieldType commentStamp: 'PanuWetterstrand 10/16/2012 09:57' prior: 0!
I represent field type that references to user defined message type. For example in next section I will stand for 'Key' and 'Value' fields after parsing.

	message KeyValuePair {
		1: Key key
		2: Value value
	}

Instance Variables:
	reference	<String> The name of the type I refer.
	definitions	<MsgPackIDL> The context (IDL) I exists. This is used to resolve the actual type.!

!MsgPackIDLMessageReferenceFieldType methodsFor: 'accessing' stamp: 'PanuWetterstrand 10/16/2012 10:07'!
referencedTypeName
	^ referencedTypeName! !

!MsgPackIDLMessageReferenceFieldType methodsFor: 'accessing' stamp: 'PanuWetterstrand 10/16/2012 10:07'!
referencedTypeName: aString
	referencedTypeName := aString.! !

!MsgPackIDLMessageReferenceFieldType methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 22:10'!
resolve: aMsgPackIDLDefinitions
	"Because I am a reference I try to return the actual type I refer if its found in given definitions"

	| resolved |
	^ (aMsgPackIDLDefinitions typeNamed: self referencedTypeName) ifNil: [ Error signal: 'Uknown type name ' , self referencedTypeName ]! !

Object subclass: #MsgPackIDLMessageVoidType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessageVoidType class
	instanceVariableNames: 'instance'!

MsgPackIDLMessageVoidType class
	instanceVariableNames: 'instance'!

!MsgPackIDLMessageVoidType class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/6/2011 13:00'!
new
	^ instance ifNil:[instance := self basicNew initialize;yourself].! !

!MsgPackIDLMessageVoidType methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 22:08'!
resolve: aMsgPackIDL
	^self! !

Object subclass: #MsgPackIDLPart
	instanceVariableNames: 'ownerDefinitions name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLPart subclass: #MsgPackIDLEnum
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDLEnum methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/2/2012 14:58'!
acceptVisitor: aMsgPackIDLVisitor
	aMsgPackIDLVisitor visitEnum: self.! !

!MsgPackIDLEnum methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/2/2012 14:30'!
acceptVisitor: aMsgPackIDLVisitor whileVisitingField: aMsgPackIDLMessageField 
	aMsgPackIDLVisitor visitEnumField: aMsgPackIDLMessageField.! !

!MsgPackIDLEnum methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 12:07'!
isEnum
	^ true.! !

!MsgPackIDLEnum methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/2/2012 14:16'!
isMessage
	^ false! !

!MsgPackIDLEnum methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/2/2012 15:15'!
nameAndValuesDo: twoArgumentBlock
	values keysAndValuesDo:  twoArgumentBlock.! !

!MsgPackIDLEnum methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 12:14'!
valueFor: aByteString 
	^values at: aByteString.! !

!MsgPackIDLEnum methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 12:14'!
values: aDictionary
	values := aDictionary.! !

MsgPackIDLPart subclass: #MsgPackIDLFunction
	instanceVariableNames: 'returnType canReturnNull'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDLFunction methodsFor: 'accessing' stamp: 'PanuWetterstrand 10/16/2012 22:33'!
canReturnNull
	^ canReturnNull! !

!MsgPackIDLFunction methodsFor: 'accessing' stamp: 'PanuWetterstrand 10/16/2012 22:33'!
canReturnNull: anObject
	canReturnNull := anObject! !

!MsgPackIDLFunction methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 22:34'!
initialize
	super initialize.
	canReturnNull := false.! !

!MsgPackIDLFunction methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 22:07'!
resolveTypes
	self returnType: (self returnType resolve: self ownerDefinitions).! !

!MsgPackIDLFunction methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/6/2011 13:11'!
returnType
	^returnType! !

!MsgPackIDLFunction methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/6/2011 13:13'!
returnType: type 
	returnType := type! !

MsgPackIDLPart subclass: #MsgPackIDLMessage
	instanceVariableNames: 'fields superClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

MsgPackIDLMessage subclass: #MsgPackIDLException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDLException methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 13:26'!
isException
	^ true! !

!MsgPackIDLException methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 13:26'!
isMessage
	^ false.! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 14:21'!
acceptVisitor: aMsgPackIDLVisitor
	aMsgPackIDLVisitor visitMessage: self.
	self fields do: [:field | field acceptVisitor: aMsgPackIDLVisitor].! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 13:30'!
addField: aMsgPackField
	self fields: (fields copyWith: aMsgPackField).! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:13'!
addFieldNamed: aString andTyped: subclassOfMsgPackIDLMessageFieldType
	self
		addField:
			(MsgPackIDLMessageField new
				name: aString;
				id: self maxFieldIndex + 1;
				type: subclassOfMsgPackIDLMessageFieldType;
				yourself)! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 18:18'!
createObject
	 ^MsgPackProxyObject for: self.! !

!MsgPackIDLMessage methodsFor: 'accessing' stamp: 'PanuSuominen 12/5/2011 20:53'!
fieldAt: fieldId
	^ (fields select: [ :field | field id = fieldId ])
		ifNotEmpty: [ :nonNil | nonNil anyOne ]
		ifEmpty: [ self superClassName ifNotNil: [ :n | (ownerDefinitions messageNamed: n) fieldAt: fieldId ] ]! !

!MsgPackIDLMessage methodsFor: 'accessing' stamp: 'PanuWetterstrand 10/15/2012 21:22'!
fieldIndexOf: fieldName
	^ ((fields select: [ :field | field name = fieldName ])
		ifNotEmpty: [ :nonNil | nonNil anyOne id]
		ifEmpty: [ self superClassName ifNotNil: [ :n | (ownerDefinitions messageNamed: n) fieldIndexOf: fieldName ] ])! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 14:06'!
fieldNames
	^ self fields collect:[:field| field name].! !

!MsgPackIDLMessage methodsFor: 'accessing' stamp: 'PanuSuominen 12/2/2011 20:53'!
fields
	^ fields! !

!MsgPackIDLMessage methodsFor: 'accessing' stamp: 'PanuSuominen 12/2/2011 20:53'!
fields: anObject
	fields := anObject! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/31/2012 13:26'!
initialize 
	super initialize.
	fields := Array new.! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/2/2012 15:14'!
isEnum
	^ false.! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 13:27'!
isException
	^ false.! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 12:06'!
isMessage
	^ true.! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 21:10'!
maxFieldIndex
	^ self fields inject: 0 into: [:max :field | max max: field id].! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 21:38'!
messageUnpack: aByteArray
	^self messageUnpackFrom: (ReadStream on: aByteArray).! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 21:37'!
messageUnpackFrom: aReadStream
	^ MsgPackProxyObject messageUnpackFrom: aReadStream usingDefinition: self! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 11:02'!
resolveTypes
	self fields do:[:f| f resolveType].! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/3/2011 17:25'!
superClassName
	^ superClassName! !

!MsgPackIDLMessage methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/3/2011 17:21'!
superClassName: aString
	superClassName := aString.! !

MsgPackIDLPart subclass: #MsgPackIDLMessageField
	instanceVariableNames: 'id literal optional type nullable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDLMessageField methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 14:26'!
acceptVisitor: aMsgPackIDLVisitor
	self type acceptVisitor: aMsgPackIDLVisitor whileVisitingField: self.! !

!MsgPackIDLMessageField methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/15/2012 21:56'!
covertToType: anObject
	^ self type convert: anObject.! !

!MsgPackIDLMessageField methodsFor: 'accessing' stamp: 'PanuSuominen 12/2/2011 20:53'!
id
	^ id! !

!MsgPackIDLMessageField methodsFor: 'accessing' stamp: 'PanuSuominen 12/2/2011 21:21'!
id: anInteger
	id := anInteger asInteger! !

!MsgPackIDLMessageField methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 11:47'!
initialize
	optional := false.
	nullable := false.! !

!MsgPackIDLMessageField methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 11:47'!
isNullable
	^nullable.! !

!MsgPackIDLMessageField methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/3/2011 12:46'!
isOptional
	^optional! !

!MsgPackIDLMessageField methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/3/2011 13:45'!
isRequired
	^self isOptional not.! !

!MsgPackIDLMessageField methodsFor: 'accessing' stamp: 'PanuSuominen 12/5/2011 11:25'!
literal
	^ literal ifNotNil: [ :nonNilValue | self type parseLiteral: nonNilValue ]! !

!MsgPackIDLMessageField methodsFor: 'accessing' stamp: 'PanuSuominen 12/5/2011 11:25'!
literal: anObject
	literal := anObject.! !

!MsgPackIDLMessageField methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 11:51'!
nullable: anObject
	nullable := anObject! !

!MsgPackIDLMessageField methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/3/2011 12:47'!
optional: aBoolean
	optional := aBoolean.! !

!MsgPackIDLMessageField methodsFor: 'accessing' stamp: 'PanuSuominen 12/5/2011 20:54'!
ownerDefinitions
	^ ownerDefinitions! !

!MsgPackIDLMessageField methodsFor: 'accessing' stamp: 'PanuSuominen 12/5/2011 20:54'!
ownerDefinitions: anObject
	ownerDefinitions := anObject! !

!MsgPackIDLMessageField methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/5/2011 20:51'!
resolveType
	self type: (self type resolve: self ownerDefinitions).! !

!MsgPackIDLMessageField methodsFor: 'accessing' stamp: 'PanuSuominen 12/3/2011 19:15'!
type
	^ type! !

!MsgPackIDLMessageField methodsFor: 'accessing' stamp: 'PanuSuominen 12/3/2011 19:15'!
type: aMsgPackIDLMessageFieldType
	^ type:= aMsgPackIDLMessageFieldType.! !

MsgPackIDLPart subclass: #MsgPackIDLNilElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDLPart methodsFor: 'accessing' stamp: 'PanuSuominen 12/5/2011 20:56'!
name
	^ name! !

!MsgPackIDLPart methodsFor: 'accessing' stamp: 'PanuSuominen 12/5/2011 20:57'!
name: anObject
	name := anObject! !

!MsgPackIDLPart methodsFor: 'accessing' stamp: 'PanuSuominen 12/5/2011 20:55'!
ownerDefinitions
	^ ownerDefinitions! !

!MsgPackIDLPart methodsFor: 'accessing' stamp: 'PanuSuominen 12/5/2011 20:55'!
ownerDefinitions: aMsgPackIDL
	ownerDefinitions := aMsgPackIDL! !

!MsgPackIDLPart methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/6/2011 12:48'!
resolveTypes! !

MsgPackIDLPart subclass: #MsgPackIDLService
	instanceVariableNames: 'functions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDLService methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/6/2011 13:02'!
functionNamed: aByteString 
	^(self functions select:[:f| f name = aByteString ]) ifNotEmpty:[:functions| functions  anyOne ] ifEmpty:[nil]! !

!MsgPackIDLService methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/6/2011 13:04'!
functions
	^ functions! !

!MsgPackIDLService methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 12/6/2011 13:11'!
functions: anArray 
	functions := anArray! !

!MsgPackIDLService methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 22:17'!
isMessage
	 ^ false! !

!MsgPackIDLService methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 10/16/2012 22:06'!
resolveTypes
	self functions do: [ :function | function resolveTypes ]! !

Object subclass: #MsgPackIDLVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-IDL'!

!MsgPackIDLVisitor methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/2/2012 14:58'!
visitEnum: aMsgPackIDLEnum! !

!MsgPackIDLVisitor methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/2/2012 14:32'!
visitEnumField: aMsgPackIDLMessageField
	self subclassResponsibility.! !

!MsgPackIDLVisitor methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:14'!
visitIntField: aMsgPackIDLField
	self subclassResponsibility.! !

!MsgPackIDLVisitor methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 15:18'!
visitListField: aMsgPackIDLMessageField 
	self subclassResponsibility! !

!MsgPackIDLVisitor methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 13:33'!
visitMessage: aMsgPackIDLMessage
	self subclassResponsibility.! !

!MsgPackIDLVisitor methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 11/1/2012 14:59'!
visitStringField: aMsgPackIDLField
	self subclassResponsibility.! !

Object subclass: #MsgPackRPCClient
	instanceVariableNames: 'writeStream queue nextMessageId process readStream requests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC'!

!MsgPackRPCClient methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 21:43'!
addRequestToQueue: aMsgPackRpcClientRequest
	queue nextPut: aMsgPackRpcClientRequest! !

!MsgPackRPCClient methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 10/26/2011 21:14'!
close
	process terminate.! !

!MsgPackRPCClient methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 10/26/2011 20:23'!
finalize
	process ifNotNil: [ :nonNilProcess | nonNilProcess terminate ].
	super finalize! !

!MsgPackRPCClient methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 22:33'!
handleResult: aMsgPackRPCResponse
	| request |
	request := (requests removeKey: aMsgPackRPCResponse messageId).
	request msgPackResponse: aMsgPackRPCResponse.
! !

!MsgPackRPCClient methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 22:32'!
initialize
	super initialize.
	queue := SharedQueue new.
	nextMessageId := 0.
	requests := Dictionary new.
	process := [ 
	[ 
	| msg |
	msg := queue nextOrNil.
	msg
		ifNotNil: [ :nonNilMsg | 
			requests at: nonNilMsg messageId put: nonNilMsg.
			nonNilMsg messagePackOn: writeStream ].
	readStream atEnd
		ifFalse: [ self handleResult: (MsgPackRPCMessage messageUnpackFrom: readStream) ].
	Processor yield ] repeat ] fork! !

!MsgPackRPCClient methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 10/26/2011 20:16'!
nextMessageId 
	^ nextMessageId := nextMessageId + 1.! !

!MsgPackRPCClient methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 10/26/2011 21:00'!
readStream: aReadWriteStream 
	readStream := aReadWriteStream! !

!MsgPackRPCClient methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 22:12'!
rpcCallMethod: aString withArgs: anArray
	| result waitSemaphore waitingRequest |
	waitingRequest := MsgPackRPCClientRequest messageId: self nextMessageId methodName: aString parameters:  anArray.
	self addRequestToQueue: waitingRequest.
	waitingRequest waitForResult.
	^ waitingRequest result! !

!MsgPackRPCClient methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 10/26/2011 21:00'!
writeStream: aWriteStream 
	writeStream := aWriteStream! !

Object subclass: #MsgPackRPCClientRequest
	instanceVariableNames: 'msgPackRequest msgPackResponse semaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-RPC'!

!MsgPackRPCClientRequest class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 22:13'!
messageId: messageId methodName: methodName parameters: parameters
	^self new
		msgPackRequest:
				(MsgPackRPCRequest new
						messageId: messageId;
						methodName: methodName;
						parameters: parameters;
						yourself);
		yourself! !

!MsgPackRPCClientRequest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 21:34'!
initialize 
	super initialize.
	semaphore := Semaphore new.! !

!MsgPackRPCClientRequest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 21:36'!
messageId
	^msgPackRequest messageId.! !

!MsgPackRPCClientRequest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 21:40'!
messagePackOn: aStream
	self msgPackRequest messagePackOn: aStream.! !

!MsgPackRPCClientRequest methodsFor: 'accessing' stamp: 'PanuSuominen 11/25/2011 21:34'!
msgPackRequest
	^ msgPackRequest! !

!MsgPackRPCClientRequest methodsFor: 'accessing' stamp: 'PanuSuominen 11/25/2011 21:34'!
msgPackRequest: anObject
	msgPackRequest := anObject! !

!MsgPackRPCClientRequest methodsFor: 'accessing' stamp: 'PanuSuominen 11/25/2011 21:34'!
msgPackResponse
	^ msgPackResponse! !

!MsgPackRPCClientRequest methodsFor: 'accessing' stamp: 'PanuSuominen 11/25/2011 22:33'!
msgPackResponse: anObject
	msgPackResponse := anObject.
	semaphore signal.! !

!MsgPackRPCClientRequest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 21:35'!
result
	^msgPackResponse result.! !

!MsgPackRPCClientRequest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/25/2011 21:34'!
waitForResult
	semaphore wait.! !

Object subclass: #MsgPackType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackType commentStamp: 'PanuSuominen 11/10/2011 19:50' prior: 0!
My subclasses represent different types of Message Pack encodings and provede ways to deserialize data. Serialization methods are in MsgPack.!

MsgPackType subclass: #MsgPackCollectionType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

MsgPackCollectionType subclass: #MsgPackByteArrayType
	uses: AnObsoleteTMsgPackByteArray + AnObsoleteTMsgPackUint16LengthCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

MsgPackByteArrayType class
	uses: AnObsoleteTMsgPackByteArray classTrait + AnObsoleteTMsgPackUint16LengthCollection classTrait
	instanceVariableNames: ''!

MsgPackByteArrayType subclass: #MsgPackByteArrayInt16Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackByteArrayInt16Type methodsFor: 'as yet unclassified' stamp: 'PanuWetterstrand 9/20/2012 19:29'!
readLength: aReadStream
	^ aReadStream uint16! !

MsgPackByteArrayType subclass: #MsgPackByteArrayInt32Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackByteArrayInt32Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:07'!
readLength: aReadStream
	^aReadStream uint32.! !

!MsgPackByteArrayType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:31'!
messageUnpackFrom: aReadStream
	| length |
	length := self readLength: aReadStream.
	^MsgPack messageUnpackByteArrayOfLength: length from: aReadStream.! !

!MsgPackCollectionType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/9/2011 09:17'!
readLength: aReadStream
	self subclassResponsibility.! !

MsgPackCollectionType subclass: #MsgPackElementArrayType
	uses: AnObsoleteTMsgPackElementArray + AnObsoleteTMsgPackUint16LengthCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

MsgPackElementArrayType class
	uses: AnObsoleteTMsgPackElementArray classTrait + AnObsoleteTMsgPackUint16LengthCollection classTrait
	instanceVariableNames: ''!

MsgPackElementArrayType subclass: #MsgPackElementArrayInt16Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackElementArrayInt16Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:17'!
readLength: aReadStream
	^aReadStream uint16.  ! !

MsgPackElementArrayType subclass: #MsgPackElementArrayInt32Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackElementArrayInt32Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:09'!
readLength: aReadStream
	^aReadStream uint32.! !

!MsgPackElementArrayType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:08'!
messageUnpackFrom: aReadStream
	^ MsgPack messageUnpackArrayOfLength: (self readLength: aReadStream) from: aReadStream.! !

MsgPackCollectionType subclass: #MsgPackFixedLengthCollectionType
	instanceVariableNames: 'fixedLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

MsgPackFixedLengthCollectionType subclass: #MsgPackFixedLengthByteArrayType
	uses: AnObsoleteTMsgPackByteArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

MsgPackFixedLengthByteArrayType class
	uses: AnObsoleteTMsgPackByteArray classTrait
	instanceVariableNames: ''!

!MsgPackFixedLengthByteArrayType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:09'!
messageUnpackFrom: aReadStream
	^ MsgPack messageUnpackByteArrayOfLength: (self readLength: aReadStream) from: aReadStream. 
	 ! !

!MsgPackFixedLengthCollectionType class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:23'!
length: length
	^self new length: length; yourself .! !

!MsgPackFixedLengthCollectionType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:13'!
length: anInteger
	fixedLength := anInteger! !

!MsgPackFixedLengthCollectionType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:13'!
readLength: aReadStream
	^fixedLength.! !

MsgPackFixedLengthCollectionType subclass: #MsgPackFixedLengthElementArrayType
	uses: AnObsoleteTMsgPackElementArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

MsgPackFixedLengthElementArrayType class
	uses: AnObsoleteTMsgPackElementArray classTrait
	instanceVariableNames: ''!

!MsgPackFixedLengthElementArrayType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:10'!
messageUnpackFrom: aReadStream
	^ MsgPack messageUnpackArrayOfLength: (self readLength: aReadStream) from: aReadStream. 
	 ! !

MsgPackFixedLengthCollectionType subclass: #MsgPackFixedLengthMapType
	uses: AnObsoleteTMsgPackMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

MsgPackFixedLengthMapType class
	uses: AnObsoleteTMsgPackMap classTrait
	instanceVariableNames: ''!

!MsgPackFixedLengthMapType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:10'!
messageUnpackFrom:  aReadStream  
		^ MsgPack messageUnpackDictionaryOfLength: (self readLength: aReadStream) from: aReadStream. 
	 ! !

MsgPackCollectionType subclass: #MsgPackMapType
	uses: AnObsoleteTMsgPackMap + AnObsoleteTMsgPackUint16LengthCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

MsgPackMapType class
	uses: AnObsoleteTMsgPackMap classTrait + AnObsoleteTMsgPackUint16LengthCollection classTrait
	instanceVariableNames: ''!

!MsgPackMapType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:21'!
messageUnpackFrom:  aReadStream  
		^ MsgPack messageUnpackDictionaryOfLength: (self readLength: aReadStream) from: aReadStream. 
	 ! !

MsgPackMapType subclass: #MsgPackMapUInt16Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackMapUInt16Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:12'!
readLength: aReadStream
	^aReadStream uint16.! !

MsgPackMapType subclass: #MsgPackMapUInt32Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackMapUInt32Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:12'!
readLength: aReadStream
	^ aReadStream uint32! !

MsgPackType subclass: #MsgPackDoubleType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackDoubleType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:33'!
messageUnpackFrom: aReadStream
	^MsgPack messageUnpackDoubleFrom: aReadStream.! !

MsgPackType subclass: #MsgPackFixedValueType
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackFixedValueType class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/7/2011 21:59'!
value: aSmallInteger
	^self new value: aSmallInteger.! !

!MsgPackFixedValueType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/7/2011 21:59'!
messageUnpackFrom: aReadStream
	"I am fixed so I just return my value"
	^value.! !

!MsgPackFixedValueType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/7/2011 21:59'!
value: aSmallInteger
	value := aSmallInteger! !

MsgPackType subclass: #MsgPackFloatType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackFloatType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:42'!
messageUnpackFrom: aReadStream	
	^MsgPack messageUnpackFloatFrom: aReadStream.
! !

MsgPackType subclass: #MsgPackInt16Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackInt16Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:35'!
messageUnpackFrom: aReadStream	
	^MsgPack messageUnpackInt16From: aReadStream.
! !

MsgPackType subclass: #MsgPackInt32Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackInt32Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:36'!
messageUnpackFrom: aReadStream	
	^MsgPack messageUnpackInt32From: aReadStream.
! !

MsgPackType subclass: #MsgPackInt64Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackInt64Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:36'!
messageUnpackFrom: aReadStream
	^ MsgPack messageUnpackInt64From: aReadStream! !

MsgPackType subclass: #MsgPackInt8Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackInt8Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:37'!
messageUnpackFrom: aReadStream	
	^MsgPack messageUnpackInt8From: aReadStream.! !

!MsgPackType methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 6/9/2011 09:17'!
messageUnpackFrom: aReadStream
	self subclassResponsibility.  ! !

MsgPackType subclass: #MsgPackUInt16Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackUInt16Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:38'!
messageUnpackFrom: aReadStream
	^MsgPack messageUnpackUInt16From: aReadStream.
! !

MsgPackType subclass: #MsgPackUInt32Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackUInt32Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:39'!
messageUnpackFrom: aReadStream
	^MsgPack messageUnpackUInt32From: aReadStream.
! !

MsgPackType subclass: #MsgPackUInt64Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackUInt64Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:39'!
messageUnpackFrom: aReadStream
	^ MsgPack messageUnpackUInt64From: aReadStream! !

MsgPackType subclass: #MsgPackUInt8Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MsgPack-Core'!

!MsgPackUInt8Type methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 11/10/2011 20:40'!
messageUnpackFrom: aReadStream
	^MsgPack messageUnpackUInt8From: aReadStream.! !

!Object methodsFor: '*msgpack' stamp: 'PanuSuominen 11/10/2011 22:49'!
messagePack
	| writeStream |
	writeStream := WriteStream on: Array new.
	self messagePackOn: writeStream.
	^ writeStream contents.! !

!Object methodsFor: '*msgpack' stamp: 'PanuSuominen 11/10/2011 22:48'!
messagePackOn: aWriteStream
	self subclassResponsibility.! !
MsgPack initialize!
